#=============================================================
#      .
#=============================================================
# source [MOM_ask_env_var UGII_CAM_DEBUG_DIR]mom_debug.tcl ;
  source [MOM_ask_env_var UGII_CAM_DEBUG_DIR]mom_review.tcl ; MOM_set_debug_mode OFF

#=============================================================
#        .
#=============================================================

 source "[MOM_ask_env_var UGII_CAM_POST_DIR]ugpost_base.tcl"

#=============================================================
#    UGPost  .
#=============================================================

	set mom_kin_arc_valid_plane		ANY
	set mom_kin_output_unit			MM
        set mom_kin_arc_output_mode			        FULL_CIRCLE; # QUADRANT
	set mom_kin_machine_type		5_axis_head_table
 # set mom_kin_machine_type                      "5_axis_dual_table"
	set mom_kin_4th_axis_limit_action	"Retract / Re-Engage"
	set mom_kin_5th_axis_limit_action	"Retract / Re-Engage"

#	set mom_kin_read_ahead_next_motion	TRUE
	set mom_kin_machine_resolution		0.001
	set mom_kin_track_center_of_ball	FALSE
	set mom_kin_4th_axis_type               "Head"
#  set mom_kin_4th_axis_type                     "Table"
#	set mom_kin_4th_axis_plane		YZ
  set mom_kin_4th_axis_plane		ZX
	set mom_kin_4th_axis_min_incr		0.001
	set mom_kin_4th_axis_min_limit		-120.000
	set mom_kin_4th_axis_max_limit		30.000
	set mom_kin_4th_axis_direction		MAGNITUDE_DETERMINES_DIRECTION
	set mom_kin_4th_axis_rotation		standard
	set mom_kin_4th_axis_zero		0.0
	set mom_kin_4th_axis_center_offset(0)	0.0
	set mom_kin_4th_axis_center_offset(1)	0.0
	set mom_kin_4th_axis_center_offset(2)	0.0
        set mom_kin_4th_axis_leader             "B"
	set mom_kin_pivot_gauge_offset		0.0

        set mom_kin_5th_axis_type               "Table"
	set mom_kin_5th_axis_plane		XY
	set mom_kin_5th_axis_min_incr		0.001
	set mom_kin_5th_axis_min_limit		-29999.000
	set mom_kin_5th_axis_max_limit		29999.000
	set mom_kin_5th_axis_direction		MAGNITUDE_DETERMINES_DIRECTION
	set mom_kin_5th_axis_rotation		standard
	set mom_kin_5th_axis_zero		0.0

	set mom_kin_5th_axis_center_offset(0)	0.0
	set mom_kin_5th_axis_center_offset(1)	0.0
	set mom_kin_5th_axis_center_offset(2)	0.0
	set mom_kin_5th_axis_leader             "C"

	set mom_kin_linearization_flag		FALSE
#	set mom_kin_independent_head		NONE
	set mom_kin_nurbs_output_type		HEIDENHAIN_POLY
	 set mom_kin_clamp_time                        "2.0"
  set mom_kin_flush_time                        "2.0"
  set mom_kin_linearization_tol                 "0.001"
  set mom_kin_max_arc_radius                    "9998.0" ; # 9999.999
  set mom_kin_max_dpm                           "5400"
  set mom_kin_max_fpm                           "15000"
  set mom_kin_max_fpr                           "1000"
  set mom_kin_max_frn                           "999999"
  set mom_kin_min_arc_length                    "0.01" ; # 0.001
  set mom_kin_min_arc_radius                    "0.011" ; # 0.001
  set mom_kin_min_dpm                           "0.0"
  set mom_kin_min_fpm                           "0.1"
  set mom_kin_min_fpr                           "0.1"
  set mom_kin_min_frn                           "0.01"
  set mom_kin_post_data_unit                    "MM"
  set mom_kin_rapid_feed_rate                   "15000"
  set mom_kin_tool_change_time                  "0.3"
  set mom_kin_x_axis_limit                      "700"
  set mom_kin_y_axis_limit                      "400"
  set mom_kin_z_axis_limit                      "480"


#=============================================================
#       G  M 
#=============================================================

	set mom_sys_program_stop_code              	0
	set mom_sys_optional_stop_code             	1

	# mom_sys_spindle_direction_code + mom_sys_coolant_code = 13
	set mom_sys_spindle_direction_code(NONE)    	13
	set mom_sys_spindle_direction_code(CLW)    	13
	set mom_sys_spindle_direction_code(CCLW)        4
	set mom_sys_spindle_direction_code(OFF)    	5

	set mom_sys_tool_change_code               	6

	set mom_sys_coolant_code(MIST)             	7
	set mom_sys_coolant_code(FLOOD)            	8
	set mom_sys_coolant_code(ON)               	8
	set mom_sys_coolant_code(TAP)              	8
	set mom_sys_coolant_code(OFF)              	9

	set mom_sys_clamp_code(ON)                 	10
	set mom_sys_clamp_code(OFF)                	11
	set mom_sys_clamp_code(AXISON)             	10
	set mom_sys_clamp_code(AXISOFF)            	11

	set mom_sys_end_of_program_code            	30

	set mom_sys_rapid_code                     	0
	set mom_sys_linear_code                    	1
	set mom_sys_circle_code(CLW)               	2
	set mom_sys_circle_code(CCLW)              	3
	set mom_sys_mcs_rotation_code              	7

	set mom_sys_cutcom_code(OFF)               	"0"
	set mom_sys_cutcom_code(LEFT)              	"L"
	set mom_sys_cutcom_code(RIGHT)             	"R"

	set mom_sys_inch_code                      	70
	set mom_sys_metric_code                    	71

	set mom_sys_output_code(ABSOLUTE)          	90
	set mom_sys_output_code(INCREMENTAL)	        91

  set mom_sys_leader(N)                         ""
  set mom_sys_leader(X)                         "X"
  set mom_sys_leader(Y)                         "Y"
  set mom_sys_leader(Z)                         "Z"
  set mom_sys_leader(fourth_axis)               "B"
  set mom_sys_leader(fifth_axis)                "C"
	set mom_sys_leader(Circle_radius) 		"R"
	set mom_sys_leader(Circle_angle)      "PA"
	set mom_sys_leader(Polar_radius)      "PR"
 set mom_kin_4th_axis_leader                   "B"
 set mom_kin_5th_axis_leader                   "C"
	set mom_sys_list_output				ON
	set mom_sys_commentary_output              	ON
	set mom_sys_header_output			ON
	set mom_sys_list_file_rows			80
	set mom_sys_list_file_columns			132
	set mom_sys_warning_output			ON
	set mom_sys_group_output			OFF
	set mom_sys_list_file_suffix			lpt
	set mom_list_file_suffix			lpt
	set mom_sys_output_file_suffix			h
	set mom_output_file_suffix			h

	set mom_sys_home_pos(0)                		400
	set mom_sys_home_pos(1)                		200
	set mom_sys_home_pos(2)                		220






#=============================================================
#   
#=============================================================

set header_check_status	            		0
set prog_start_flag                        	0
set prog_number                            	12345
set mom_cycle_rapid_to_pos(0)         		0
set mom_cycle_rapid_to_pos(1)        		0
set mom_cycle_rapid_to_pos(2)         		0
set mom_cycle_feed_to_pos(0)          		0
set mom_cycle_feed_to_pos(1)          		0
set mom_cycle_feed_to_pos(2)          		0
set mom_cycle_retract_to_pos(0)       		0
set mom_cycle_retract_to_pos(1)       		0
set mom_cycle_retract_to_pos(2)       		0
set mom_point1_pos(0) 				-100.0
set mom_point1_pos(1) 				-100.0
set mom_point1_pos(2) 				-50.0
set mom_point2_pos(0) 				100.0
set mom_point2_pos(1) 				100.0
set mom_point2_pos(2) 				0.0
set mom_offset_block				0.0
set mom_smooth_path				"OFF"
set mom_tolerance_on_off			"OFF"
set tolerances				        0.01
set mom_small_steps				"OFF"
set status_block_create				0
set cutcom_on 					0
set mom_zero_point_set 				88
set status_tool_change				0
set mom_prev_pos_z				-9999.999
set first_move_after_MCSROT			0
set MCSROT_flag					0
set is_MCSROT_matrix_set			0
set first_motion_flag				0
set spindle_off_flag 				0
set mom_contact_status				UNDEFINED ; # ON
set mom_cycle_status				UNDEFINED
set mom_cycle_delay				0.1
set mom_output_vectors_on			"OFF"
set code_cutcom                                 0
set out_m128                                    129
set status_rot     0
set status_rot_m     0
set status_rot_ini 0
set a_angle  0
set b_angle  0
set c_angle  0
set   mom_machine_time_dmu                        0
set   mom_machine_time_dmu_1                        0
set  prev_theta_value   0
set prev_c_value   0
set nn 0
set  angle  0
set   mom_cycle_19_on_off                         "OFF"
set    mom_pos_arc_plane                        "XY"
set   status_from                           0
set  mom_work_coordinate_number             "1"
set zero_point                                 0
set  tool_count                             1
#=============================================================
proc  MOM_start_of_program {} {
#       .
#=============================================================
	global mom_part_name
	global is_from
	global mom_cutcom_status mom_cutcom_mode
	global mom_spindle_rpm

#      UNDEFINED
	  set mom_coolant_status 	UNDEFINED
	  set mom_cutcom_status  	UNDEFINED
  	set mom_clamp_status   	UNDEFINED
  	set mom_cycle_status   	UNDEFINED
  	set mom_spindle_status 	UNDEFINED
  	set mom_cutcom_plane   	UNDEFINED

#   
	  catch {unset mom_cutcom_adjust_register}
	  catch {unset mom_tool_adjust_register}
  	catch {unset mom_tool_length_adjust_register}
  	catch {unset mom_length_comp_register}
  	catch {unset mom_flush_register}
  	catch {unset mom_wire_cutcom_adjust_register}
     PB_CMD_init_vars
#     
	OPEN_files
#       
	LIST_FILE_HEADER

	global mom_warning_info
	set mom_warning_info "\n  DMU40_monoBLOCK ( - HEIDENHAIN)\n"
  MOM_output_to_listing_device $mom_warning_info  ; #  MOM_catch_warning ;

	set is_from ""
	set mom_spindle_rpm 0.0
}


#=============================================================
proc MOM_msys {} {
#       MOM_msys
#=============================================================
	global status_block_create mom_tolerance_on_off
	global status_zero_shift mom_spindle_speed tolerances zero_g_code
#         
#       iTNC-530
	if {$status_block_create == "0"} {
		MOM_block_create
#		MOM_output_literal "L M129"
	}
#        

}


#=============================================================
proc MOM_set_csys {} {
#=============================================================
  if [llength [info commands PB_CMD_kin_set_csys] ] {
    PB_CMD_kin_set_csys
  }
}



#=============================================================
proc MOM_operator_message {} {
#        
#=============================================================
     global mom_operator_message
     MOM_output_literal ";$mom_operator_message"
}


#=============================================================
proc MOM_end_of_program { } {
#       
#=============================================================
   	global mom_group_name mom_machine_time line1 mom_machine_time_dmu mom_machine_time_dmu_1
   	global mom_kin_tool_change_time mom_tool_count warning_1 nn tool_count
   	global mom_cycle_19_on_off 

#   19 (  )      
      MOM_output_literal "M129"
       MOM_output_literal "L Z-1. R0 FMAX M91"
       MOM_output_literal "L Y-1. R0 FMAX M91"
    #   MOM_output_literal "L X-1. R0 FMAX M91"
       MOM_output_literal "L B0 C0 R0 FMAX"
	  
    MOM_output_literal "TOOL CALL 0"
    MOM_output_literal "M30"

    set machine_time $mom_machine_time_dmu_1
    
    #####     - 
#################################################
 global mom_operation_type
 if {$mom_operation_type!="Point to Point" } {
 	     
 	  if  {$machine_time <10.0} {   set machine_time   [ expr $machine_time * 1.0 ] }
 	  if  {$machine_time >=10.0 && $machine_time <20.0} {   set machine_time   [ expr $machine_time * 1.1 ] }
	  if  {$machine_time >=20.0} {   set machine_time   [ expr $machine_time * 1.15 ] }
 	}
 	
#########################################################
    set machine_time [ expr ($tool_count*$mom_kin_tool_change_time + $machine_time ) ]
    set line1 [format "; MACHINE TIME = %.2f min " $machine_time ]
  	set tm1 [ expr int($machine_time/60.0) ]
  	set tm2 [ expr ($machine_time/60.0 - $tm1) * 60.0 ]
  	set line2 [format "( %.0f hour %.0f min)" $tm1 $tm2]
  	if {$tm1!=0} { append line1 $line2 ; }
  	set mom_machine_time $machine_time
    MOM_output_literal "$line1"

    for {set l 1} {$l <= $nn} {incr l} { MOM_output_literal "$warning_1($l)" }

    global prog_name
	  MOM_output_literal "END PGM $prog_name MM"

 if {$mom_cycle_19_on_off == "ON"} {
     	set mom_warning_info "WARNING:      19 (  )!"
       MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
     	
     	
    }    
  	LIST_FILE_TRAILER

  	CLOSE_files
}
#=============================================================
proc PB_start_of_program { } {
#=============================================================

   if [llength [info commands PB_CMD_kin_start_of_program] ] {
      PB_CMD_kin_start_of_program
   }

   
}


 #=============================================================
proc PB_CMD_init_vars { } {
#=============================================================
global mom_sys_helix_pitch_type mom_kin_helical_arc_output_mode


 set mom_sys_helix_pitch_type	"none"
#
# The default setting for mom_sys_helix_pitch_type is "rise_radian".
# This is the most common.  Other choices are:
#
#    "rise_radian"              Measures the rise over one radian.
#    "rise_revolution"          Measures the rise over 360 degrees.
#    "none"                     Will suppress the output of pitch.
#    "other"                    Allows you to calculate the pitch
#                               using your own formula.
#
# This custom command uses the block template circular_move to output
# the helix block.  If your post uses a block template with a different
# name, you must edit the line that outputs the helix block.

#
#  The following variable deines the output mode for helical records.
#
#  FULL_CIRCLE  -- This mode will output a helix record for each 360
#                  degrees of the helix.
#  QUADRANT  --    This mode will output a helix record for each 90
#                  degrees of the helix.
#  LINEAR  --      This mode will output the entire helix as linear gotos.
#  END_POINT --    This mode will assume the control can define an entire
#                  helix in a single block.

 set mom_kin_helical_arc_output_mode END_POINT

 MOM_reload_kinematics
}
#=============================================================
proc MOM_nurbs_move { } {
#       
#=============================================================
	global mom_nurbs_point_count
	global mom_nurbs_points
	global mom_nurbs_coefficients
	global xe ye ze
	global ii
	global x0 x1 x2
	global y0 y1 y2
	global z0 z1 z2
	global E_string_x0 E_string_x1 E_string_x2
	global E_string_y0 E_string_y1 E_string_y2
	global E_string_z0 E_string_z1 E_string_z2
	global nurbs_precision
	global comp_value mom_smooth_path

	set E_string_x0 ""
	set E_string_x1 ""
	set E_string_x2 ""
	set E_string_y0 ""
	set E_string_y1 ""
	set E_string_y2 ""
	set E_string_z0 ""
	set E_string_z1 ""
	set E_string_z2 ""

	MOM_force once X Y Z K3X K2X K1X K3Y K2Y K1Y K3Z K2Z K1Z

	set xe $mom_nurbs_points(0,0)
	set ye $mom_nurbs_points(0,1)
	set ze $mom_nurbs_points(0,2)

#	if {$mom_smooth_path == "ON"} {
#		MOM_do_template start_spline_m90
#	} else  {
#		MOM_do_template start_spline
#	}

	MOM_force once X Y Z K3X K2X K1X K3Y K2Y K1Y K3Z K2Z K1Z

	for {set ii 0} {$ii < [expr $mom_nurbs_point_count-1]} {incr ii} {
		set xe $mom_nurbs_points($ii,0)
		set ye $mom_nurbs_points($ii,1)
		set ze $mom_nurbs_points($ii,2)
		set nurbs_precision 1.0

		set x0 [expr $mom_nurbs_coefficients($ii,0)*$nurbs_precision]
		set x1 [expr $mom_nurbs_coefficients($ii,1)*$nurbs_precision]
		set x2 [expr $mom_nurbs_coefficients($ii,2)*$nurbs_precision]
		set y0 [expr $mom_nurbs_coefficients($ii,3)*$nurbs_precision]
		set y1 [expr $mom_nurbs_coefficients($ii,4)*$nurbs_precision]
		set y2 [expr $mom_nurbs_coefficients($ii,5)*$nurbs_precision]
		set z0 [expr $mom_nurbs_coefficients($ii,6)*$nurbs_precision]
		set z1 [expr $mom_nurbs_coefficients($ii,7)*$nurbs_precision]
		set z2 [expr $mom_nurbs_coefficients($ii,8)*$nurbs_precision]

		set comp_value [expr abs($x0)]

		if { $comp_value  >= 10.0 && $comp_value < 100.0} {
			set x0 [expr $x0/10.0] ; set E_string_x0 "E1"
		} elseif { $comp_value >= 100.0 && $comp_value < 1000.0} {
			set x0 [expr $x0/100.0] ; set E_string_x0 "E2"
		} elseif { $comp_value >=  1000.0 && $comp_value < 10000.0} {
			set x0 [expr $x0/1000.0] ; set E_string_x0 "E3"
		} elseif { $comp_value >=  10000.0 && $comp_value < 100000.0} {
			set x0 [expr $x0/10000.0] ; set E_string_x0 "E4"
		} else { set E_string_x0 ""}

		set comp_value [expr abs($x1)]

		if { $comp_value >=  10.0 && $comp_value < 100.0} {
			set x1 [expr $x1/10.0] ; set E_string_x1 "E1"
		} elseif { $comp_value >=  100.0 && $comp_value < 1000.0} {
			set x1 [expr $x1/100.0] ; set E_string_x1 "E2"
		} elseif { $comp_value >=  1000.0 && $comp_value < 10000.0} {
			set x1 [expr $x1/1000.0] ; set E_string_x1 "E3"
		} elseif { $comp_value >=  10000.0 && $comp_value < 100000.0} {
			set x1 [expr $x1/10000.0] ; set E_string_x1 "E4"
		} else {
			set E_string_x1 ""}

		set comp_value [expr abs($x2)]

		if {$comp_value >=  10.0 && $comp_value < 100.0} {
			set x2 [expr $x2/10.0] ; set E_string_x2 "E1"
		} elseif { $comp_value >=  100.0 && $comp_value < 1000.0} {
			set x2 [expr $x2/100.0] ; set E_string_x2 "E2"
		} elseif { $comp_value >=  1000.0 && $comp_value < 10000.0} {
			set x2 [expr $x2/1000.0] ; set E_string_x2 "E3"
		} elseif { $comp_value >=  10000.0 && $comp_value < 100000.0} {
			set x2 [expr $x2/10000.0] ; set E_string_x2 "E4"
		} else {set E_string_x2 ""}

		set comp_value [expr abs($y0)]

		if {$comp_value >=  10.0 && $comp_value < 100.0} {
			set y0 [expr $y0/10.0] ; set E_string_y0 "E1"
		} elseif { $comp_value >=  100.0 && $comp_value < 1000.0} {
			set y0 [expr $y0/100.0] ; set E_string_y0 "E2"
		} elseif { $comp_value >=  1000.0 && $comp_value < 10000.0} {
			set y0 [expr $y0/1000.0] ; set E_string_y0 "E3"
		} elseif { $comp_value >=  10000.0 && $comp_value < 100000.0} {
			set y0 [expr $y0/10000.0] ; set E_string_y0 "E4"
		} else {set E_string_y0 ""}

		set comp_value [expr abs($y1)]

		if { $comp_value >=  10.0 && $comp_value < 100.0} {
			set y1 [expr $y1/10.0] ; set E_string_y1 "E1"
		} elseif { $comp_value >=  100.0  && $comp_value < 1000.0} {
			set y1 [expr $y1/100.0] ; set E_string_y1 "E2"
		} elseif { $comp_value >=  1000.0  && $comp_value < 10000.0} {
			set y1 [expr $y1/1000.0] ; set E_string_y1 "E3"
		} elseif { $comp_value >=  10000.0  && $comp_value < 100000.0} {
			set y1 [expr $y1/10000.0] ; set E_string_y1 "E4"
		} else {set E_string_y1 ""}

		set comp_value [expr abs($y2)]

		if { $comp_value >=  10.0 && $comp_value < 100.0} {
			set y2 [expr $y2/10.0] ; set E_string_y2 "E1"
		} elseif { $comp_value >=  100.0 && $comp_value < 1000.0} {
			set y2 [expr $y2/100.0] ; set E_string_y2 "E2"
		} elseif { $comp_value >=  1000.0 && $comp_value < 10000.0} {
			set y2 [expr $y2/1000.0] ; set E_string_y2 "E3"
		} elseif { $comp_value >=  10000.0 && $comp_value < 100000.0} {
			set y2 [expr $y2/10000.0] ; set E_string_y2 "E4"
		} else {set E_string_y2 ""}

		set comp_value [expr abs($z0)]

		if { $comp_value >=  10.0 && $comp_value < 100.0} {
			set z0 [expr $z0/10.0] ; set E_string_z0 "E1"
		} elseif { $comp_value >=  100.0 && $comp_value < 1000.0} {
			set z0 [expr $z0/100.0] ; set E_string_z0 "E2"
		} elseif {$comp_value >=  1000.0 && $comp_value < 10000.0} {
			set z0 [expr $z0/1000.0] ; set E_string_z0 "E3"
		} elseif {$comp_value >=  10000.0 && $comp_value < 100000.0} {
			set z0 [expr $z0/10000.0] ; set E_string_z0 "E4"
		} else {set E_string_z0 ""}

		set comp_value [expr abs($z1)]

		if {$comp_value >=  10.0 && $comp_value < 100.0} {
			set z1 [expr $z1/10.0] ; set E_string_z1 "E1"
		} elseif {$comp_value >=  100.0 && $comp_value < 1000.0} {
			set z1 [expr $z1/100.0] ; set E_string_z1 "E2"
		} elseif {$comp_value >=  1000.0 && $comp_value < 10000.0} {
			set z1 [expr $z1/1000.0] ; set E_string_z1 "E3"
		} elseif {$comp_value >=  10000.0 && $comp_value < 100000.0} {
			set z1 [expr $z1/10000.0] ; set E_string_z1 "E4"
		} else {set E_string_z1 ""}

		set comp_value [expr abs($z2)]

		if { $comp_value >=  10.0 && $comp_value < 100.0} {
			set z2 [expr $z2/10.0] ; set E_string_z2 "E1"
		} elseif {$comp_value >=  100.0 && $comp_value < 1000.0} {
			set z2 [expr $z2/100.0] ; set E_string_z2 "E2"
		} elseif {$comp_value >=  1000.0 && $comp_value < 10000.0} {
			set z2 [expr $z2/1000.0] ; set E_string_z2 "E3"
		} elseif {$comp_value >=  10000.0 && $comp_value < 100000.0} {
			set z2 [expr $z2/10000.0] ; set E_string_z2 "E4"
		} else {set E_string_z2 ""}

		if {$mom_smooth_path == "ON"} {
			MOM_do_template spline_tnc_m90
		} else  {
			MOM_do_template spline_tnc
		}
	}

}


#=============================================================
proc  MOM_start_of_path {} {
#       .
#=============================================================
	global mom_path_name
	global mom_tool_name
	global mom_out_angle_pos
	global status_rot_m

	global mom_operation_name
	MOM_output_literal " ; "
	MOM_output_literal " ; $mom_operation_name "

        if {$status_rot_m == 0} {
	   MOM_force once M_spindle M_coolant S X Y Z R F Axis_4th Axis_5th
         } else {
	   MOM_force once M_spindle M_coolant S X Y Z R F
	   MOM_suppress once Axis_4th Axis_5th M128
        }
}


#=============================================================
proc  MOM_end_of_path {} {
#       
#=============================================================
	global mom_path_name
	global first_motion_flag
  
	set first_motion_flag 0
	MOM_suppress off I J K
}

#=============================================================
proc MOM_start_of_group {} {
#      UG   ,
#    
#=============================================================
	global mom_output_file_basename mom_group_name
	global header_check_status mom_operation_name
	global mom_date mom_machine_name mom_logname
	global mom_ug_version pb_start_of_program_flag

  global prog_name
  set prog_name ""
  if {[info exists mom_operation_name]} { set prog_name $mom_operation_name }
  if {[info exists mom_group_name]} { set prog_name $mom_group_name }

	set prog_name $mom_output_file_basename

	if { $header_check_status == 0} {
		set prog_name [string toupper $prog_name]
		MOM_output_literal "BEGIN PGM $prog_name MM"
# 		MOM_do_template sel_table

		  set strname "" ;
  if [llength [info commands PB_part_name_ex] ] {
   	        set strname [ PB_part_name_ex ]
   	        set strname [ MOM_string_toupper $strname ]
      
       		MOM_output_literal ";Part: $strname "
  }

  set strmaterial "" ;
  if [llength [info commands PB_part_material] ] {
       set strmaterial [ PB_part_material ] ;
       
 #      		MOM_output_literal ";Material: $strmaterial" 
  }
  
		set mom_ug_version [string toupper $mom_ug_version]
		MOM_output_literal "; GENERATE BY: $mom_ug_version"
		set mom_machine_name [string toupper $mom_machine_name]
		MOM_output_literal "; MACHINE: $mom_machine_name"
		set mom_date [string toupper $mom_date]
		MOM_output_literal "; DATE: $mom_date"
		set mom_logname [string toupper $mom_logname]
		MOM_output_literal "; PROGRAMMER: $mom_logname"
		set header_check_status 1
	}
	
	  PB_start_of_program ; set pb_start_of_program_flag 1
}


#=============================================================
proc MOM_end_of_group {} {
#      
#=============================================================
}


#=============================================================
proc  MOM_tool_change {} {
#      
#=============================================================
	global mom_tool_name status_tool_change  out_m128 tool_count
	
	set status_tool_change 0
	 #  MOM_output_literal "M129"
	 set out_m128 129
	   	 	MOM_do_template outM128
       MOM_output_literal "L Z-1. R0 FMAX M91"
        MOM_output_literal "L M15"
       MOM_output_literal "L Y-1. R0 FMAX M91"
    #   MOM_output_literal "L X-1. R0 FMAX M91"
       MOM_output_literal "L B0 C0 R0 FMAX"
       incr tool_count
}


#=============================================================
proc  MOM_first_tool {} {
#       
#=============================================================
	global mom_tool_name
}


#=============================================================
proc  MOM_initial_move {} {
#         .
#=============================================================
	global first_motion_flag mom_cycle_status mom_motion_type mom_tool_axis
	global mom_prev_pos_z mom_pos_z leader_4th leader_5th status_rot 
  global mom_imported_path_status mom_tolerance_on_off
  global mom_kin_arc_output_mode mom_operation_name mom_warning_info 
  global status_rot status_rot_m mom_out_angle_pos
  global mom_rotation_angle mom_cycle_19_on_off status_from
#     ,     
#     ,    .
#                         !!!!!!
	set leader_4th "B"
	set leader_5th "C"

	#        
	if {$mom_tolerance_on_off == "ON"} {
  		MOM_do_template tolerances_1
  		MOM_do_template tolerances_2
#  		MOM_do_template tolerances_3
  	}
#    
	MOM_spindle_rpm
		MOM_do_template from_move_M91_1
	MOM_output_literal "L B0 C0 R0 FMAX"

	  if {[info exists mom_imported_path_status]==1} {
     if {"YES"==[string toupper "$mom_imported_path_status"]} {
       set mom_warning_info "WARNING: =$mom_operation_name -   ( -   !)"
       MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;

      } else {
      		if {$status_from  == 1} {
      	      		MOM_force once  X Y Z
#	MOM_do_template from_move
		MOM_do_template from_move_xy
	#	MOM_do_template from_move_M91_1
       }
#      	      		MOM_force once  X Y Z
#	MOM_do_template from_move
       }
   }
 #          MOM_reload_kinematics
           if {  $mom_rotation_angle!=0.0 } {
          MOM_do_template fifth_axis_rotate_move
        }  
        	 #   19 (  )      
   if {$mom_cycle_19_on_off == "ON"} {
   	 	MOM_do_template outM128
   	       MOM_do_template from_move_M91_1
   	        MOM_do_template from_move_M91_2
    
			set rot_table_1 [format "CYCL DEF 19.0 WORKING PLANE"]
			set rot_table_2 [format "CYCL DEF 19.1 A%.3f B0 C%.3f F2000 " $mom_out_angle_pos(0) $mom_out_angle_pos(1)]

	        MOM_output_literal "$rot_table_1"
	        MOM_output_literal "$rot_table_2"
	        	        MOM_do_template rotate_bcq
	      		MOM_force once  X Y Z
	          
                	} else {
  MOM_force once  X Y Z Axis_4th Axis_5th

	} 		       
     
	if {$mom_motion_type == "RAPID"} {
		if {$mom_cycle_status == "ON"} {
			MOM_do_template rapid_cycle_xy
			MOM_do_template rapid_cycle_z
		} else {
			  	if {($mom_out_angle_pos(1) != 0  || $mom_out_angle_pos(0) != 0) && $mom_cycle_19_on_off == "OFF" } {
	            MOM_do_template rapid_ac
MOM_force once Axis_4th Axis_5th
}
if { $mom_cycle_19_on_off == "ON" } {
		MOM_do_template rapid_xyz
			} else {		
			MOM_do_template rapid_xy
			MOM_do_template rapid_z
		}
	}
	} elseif {$mom_motion_type == "CYCLE"} {
		MOM_do_template rapid_cycle_xy
		MOM_do_template rapid_cycle_z
	} else {
		MOM_linear_move
	}
	set first_motion_flag 1

}


#=============================================================
proc PROGRAM_START {} {
#      User Define Command
# "PARTNO"
#=============================================================
	global prog_start_flag
	global prog_number

	if {$prog_start_flag == 0} {
		MOM_suppress always N
		MOM_output_literal "BEGIN PRG $prog_number MM"
		MOM_suppress off    N
		set prog_start_flag 1
	}
}


#=============================================================
proc MOM_block_create { } {
#    2-  3-   ,  
#      
#=============================================================
	global mom_point1_pos
	global mom_point2_pos
	global status_block_create
	global mom_offset_block
	global mom_work_coordinate_number zero_point
	MOM_force once X Y Z
	set mom_point1_pos(0) [expr $mom_point1_pos(0)-$mom_offset_block]
	set mom_point1_pos(1) [expr $mom_point1_pos(1)-$mom_offset_block]
	set mom_point1_pos(2) [expr $mom_point1_pos(2)-$mom_offset_block]
	set mom_point2_pos(0) [expr $mom_point2_pos(0)+$mom_offset_block]
	set mom_point2_pos(1) [expr $mom_point2_pos(1)+$mom_offset_block]
	MOM_do_template start_block
	MOM_do_template end_block
	
		    if {$zero_point == 0} {
	    		  	   MOM_output_literal "CYCL DEF 247 DATUM SETTING Q339=+$mom_work_coordinate_number;  DATUM NUMBER"
	    		  	  }
	    		  	  
	set status_block_create 1
	MOM_output_literal "L M129"
	#MOM_do_template outM128
}


#=============================================================
proc MOM_first_move {} {
#        ,
#       .
#=============================================================
global mom_motion_event status_rot_m
	global first_motion_flag  status_rot 
	global mom_rotation_angle 
	global mom_cycle_19_on_off mom_out_angle_pos mom_prev_out_angle_pos	
	global mom_rotary_delta_4th mom_rotary_delta_5th mom_motion_type
	set first_motion_flag 1

  
	          if {$mom_cycle_19_on_off == "ON"&& (  $mom_rotary_delta_4th !=0.0 ||\
          $mom_rotary_delta_5th !=0.0	)} {
           	  	MOM_do_template outM128
           	
   	       MOM_do_template from_move_M91_1
   	        MOM_do_template from_move_M91_2
    
			set rot_table_1 [format "CYCL DEF 19.0 WORKING PLANE"]
			set rot_table_2 [format "CYCL DEF 19.1 A%.3f B0 C%.3f F2000 " $mom_out_angle_pos(0) $mom_out_angle_pos(1)]

	        MOM_output_literal "$rot_table_1"
	        MOM_output_literal "$rot_table_2"
	        	        MOM_do_template rotate_bcq
	       
	        	MOM_force once X Y Z
	                	} 
	              if {  $mom_cycle_19_on_off == "OFF" } {     	
	    	    MOM_force once  X Y Z Axis_4th Axis_5th

                	}
	        if {  $mom_rotation_angle!=0.0 } {
	        	
          MOM_do_template fifth_axis_rotate_move
        }
        
	catch { MOM_$mom_motion_event }
	set first_motion_flag 1
}


#=============================================================
proc MOM_from_move { } {
#       FROM,   .
#=============================================================
 global mom_from_pos mom_mcs_goto from_pos status_from
 catch { COOLANT_SET ; CUTCOM_SET ; SPINDLE_SET ; RAPID_SET ;  MODES_SET ; }

      set  from_pos(0)  $mom_mcs_goto(0)
      set  from_pos(1)  $mom_mcs_goto(1)
      set  from_pos(2)  $mom_mcs_goto(2)

      set   status_from   1
}


#=============================================================
proc MOM_gohome_move {} {
#       GOHOME,   .
#=============================================================
	global mom_pos mom_prev_pos mom_gohome_pos c_adr mom_out_angle_pos
	global leader_4th leader_5th mom_output_vectors_on mom_tool_axis
  global mom_cycle_19_on_off

	set i [format "%-.7f" $mom_tool_axis(0)]
	set j [format "%-.7f" $mom_tool_axis(1)]
	set k [format "%-.7f" $mom_tool_axis(2)]

  #     
  if { $k>1.0  } { MOM_abort "      GOHOME!!!!!!" }
  if { $k<-1.0 } { MOM_abort "      GOHOME!!!!!!" }

  if {$mom_pos(2) < $mom_prev_pos(2) } {
   if {$mom_output_vectors_on == "ON"} {
 	MOM_force once X Y Z TX TY TZ
	MOM_do_template gohome_xy_vectors
     } else {
	set c_adr $mom_out_angle_pos(1)
	#MOM_output_literal "c_adr $c_adr"
 		if { ($c_adr>=360 ||$c_adr<=-360 ) && $mom_cycle_19_on_off == "OFF" } {
   		MOM_do_template gohome_ac
   	}
   	MOM_do_template gohome_xy
    }
    MOM_do_template gohome_z
  } else {
    if {$mom_output_vectors_on == "ON"} {
	MOM_force once X Y Z TX TY TZ
	MOM_do_template gohome_z_vectors
      } else {
#	MOM_do_template gohome_z

     }
     	set c_adr $mom_out_angle_pos(1)
 #    		MOM_output_literal "c_adr $c_adr"
   	if { ($c_adr>=360 ||$c_adr<=-360 ) && $mom_cycle_19_on_off == "OFF" } {
   		MOM_do_template gohome_ac
   	}
#    MOM_do_template gohome_xy
 }

#   	set mom_prev_pos_z $mom_pos_z
}


#=============================================================
proc MOM_linear_move { } {
#       .
#=============================================================
	global cutcom_mode mom_cutcom_mode mom_cutcom_status
	global mom_pos mom_prev_pos
	global mom_smooth_path mom_small_steps
	global mom_motion_distance mom_tool_diameter
	global cutcom_on mom_contact_status
	global mom_output_vectors_on
	global mom_tool_axis

	set al1 [COUNT_alk $mom_pos(0) $mom_pos(1) al1]
#       MOM_output_literal "al1=  $al1"

	PB_limit_angle

	if {$mom_contact_status == "ON"} {
		MOM_force once X Y Z NX NY NZ
		MOM_do_template linear_move_3d
	} elseif {$mom_output_vectors_on == "ON"} {
		MOM_force once X Y Z TX TY TZ
		MOM_do_template linear_move_vectors
	} else {
		if {$mom_small_steps == "ON" 		&&
			$mom_cutcom_status == "ON"	&&
			$mom_motion_distance <= $mom_tool_diameter} {
				MOM_do_template feedrate_tnc
				MOM_do_template linear_move_m97
		} elseif {$mom_smooth_path == "ON"} {
			if {$cutcom_on == 1} {
				MOM_do_template linear_move
				set cutcom_on 0
			} else {
				MOM_do_template feedrate_tnc
				MOM_do_template linear_move_m90
			}
		} else  {
			MOM_do_template linear_move
		}
	}
}


#=============================================================
proc MOM_circular_move { } {
#=============================================================
global mom_arc_direction mom_cycle_19_on_off mom_pos_arc_plane mom_pos_arc_axis
	global mom_arc_axis out_m128 kl_origin_c mom_rotation_angle

   	if { $out_m128 == 128 && $mom_cycle_19_on_off == "OFF" && $mom_rotation_angle==0.0  } {
		MOM_abort "       !!!!!"
   	}

		if {[format "%.6f" $mom_pos_arc_axis(2)] == "1" || [format "%.6f" $mom_pos_arc_axis(2)] == "-1"} {
		MOM_force once XC YC
		MOM_suppress once ZC
	} elseif {[format "%.6f" $mom_pos_arc_axis(1)] == "1" || [format "%.6f" $mom_pos_arc_axis(1)] == "-1"} {
		 MOM_force once XC ZC
		 MOM_suppress once YC
	} elseif {[format "%.6f" $mom_pos_arc_axis(0)] == "1" || [format "%.6f" $mom_pos_arc_axis(0)] == "-1"} {
		 MOM_force once YC ZC
		 MOM_suppress once XC
	}
   	MOM_do_template circle_center
   	
   	   	if {[format "%.6f" $mom_pos_arc_axis(2)] == "1" || [format "%.6f" $mom_pos_arc_axis(2)] == "-1"} {
		 MOM_force once X Y
		MOM_suppress once Z
	} elseif {[format "%.6f" $mom_pos_arc_axis(1)] == "1" || [format "%.6f" $mom_pos_arc_axis(1)] == "-1"} {
		 MOM_force once X Z
		 MOM_suppress once Y
	} elseif {[format "%.6f" $mom_pos_arc_axis(0)] == "1" || [format "%.6f" $mom_pos_arc_axis(0)] == "-1"} {
		 MOM_force once Y Z
		 MOM_suppress once X
	}
     
   	if { $mom_arc_direction == "CLW"} {
      		MOM_do_template circle_end_cw
   	} elseif { $mom_arc_direction == "CCLW" } {
     		MOM_do_template circle_end_ccw
   	}
}

#=============================================================
proc  MOM_rapid_move {} {
#     .
#=============================================================
	global mom_coolant_mode mom_coolant_status mom_output_vectors_on
	global mom_pos mom_prev_pos mom_pos_z mom_prev_pos_z

	set mom_coolant_status $mom_coolant_mode
	if {$mom_output_vectors_on == "ON"} {
		MOM_force once X Y Z TX TY TZ
		MOM_do_template rapid_xyz_vectors
	} else {
              MOM_do_template rapid_xyz

   	}
#   	set mom_prev_pos_z $mom_pos_z
}

#=============================================================
proc MOM_helix_move { } {
#=============================================================
   global mom_arc_direction  mom_arc_axis  mom_arc_angle
   global out_m128 mom_rotation_angle mom_cycle_19_on_off
   global mom_pos_arc_plane
   global mom_sys_cir_vector
   global mom_sys_helix_pitch_type
   global mom_helix_pitch
   global mom_prev_pos mom_pos_arc_center
   global PI
    	if { $out_m128 == 128 && $mom_rotation_angle==0.0 && $mom_cycle_19_on_off == "OFF"} {
		MOM_abort "       !!!!!"
   	}
   switch $mom_pos_arc_plane {
      XY { MOM_suppress once ZC ; set cir_index 2 }
      YZ { MOM_suppress once XC ; set cir_index 0 }
      ZX { MOM_suppress once YC ; set cir_index 1 }
   }

   switch $mom_sys_helix_pitch_type {
      none { }
      rise_revolution { set pitch $mom_helix_pitch }
      rise_radian { set pitch [expr $mom_helix_pitch / ($PI * 2.0)]}
      other {
#
#	Place your custom helix pitch code here
#
      }
      default { set mom_sys_helix_pitch_type "none" }
   }

   MOM_force once X Y Z

   if {$mom_sys_helix_pitch_type != "none"} {
      MOM_force once XC YC 

      switch $mom_sys_cir_vector {
         "Vector - Arc Center to Start" {
            set mom_prev_pos($cir_index) $pitch
            set mom_pos_arc_center($cir_index) 0.0
         }
         "Vector - Arc Start to Center" {
            set mom_prev_pos($cir_index) 0.0
            set mom_pos_arc_center($cir_index) $pitch
         }
         "Unsigned Vector - Arc Center to Start" {
            set mom_prev_pos($cir_index) 0.0
            set mom_pos_arc_center($cir_index) $pitch
         }
         "Vector - Absolute Arc Center" {
            set mom_pos_arc_center($cir_index) $pitch
         }
      }
   }

  MOM_do_template circle_center


  global mom_prev_mcs_goto mom_arc_center 
  global polar_angle
  set  polar_angle  0.0

  switch $mom_pos_arc_plane {
      XY { set y [ expr ($mom_prev_pos(1) - $mom_pos_arc_center(1))];
           set x  [ expr ($mom_prev_pos(0) - $mom_pos_arc_center(0))]; }
      YZ { set y [ expr ($mom_prev_pos(2) - $mom_pos_arc_center(2))];
      	   set x  [ expr ($mom_prev_pos(1) - $mom_pos_arc_center(1))]; }
      ZX { set y [ expr ($mom_prev_pos(2) - $mom_pos_arc_center(2))];
      	   set x  [ expr ($mom_prev_pos(1) - $mom_pos_arc_center(1))]; }
   }
 #   set y [ expr ($mom_prev_mcs_goto(1) - $mom_arc_center(1))];
 #   set x  [ expr ($mom_prev_mcs_goto(0) - $mom_arc_center(0))];
  set polar_angle [ ATAN $y $x ]

  MOM_do_template helix_linear


  global mom_sys_leader
  set mom_sys_leader(Circle_angle) "IPA"
#  set mom_sys_leader(X) "IX"
#  set mom_sys_leader(Y) "IY"
#  set mom_sys_leader(Z) "IZ"

     switch $mom_pos_arc_plane {
      XY { MOM_suppress once X Y  

      	 set mom_sys_leader(Z) "IZ" 
      	}
      YZ { MOM_suppress once Y Z  
      	 set mom_sys_leader(X) "IZ"
      	}
      ZX { MOM_suppress once X Z  	
         set mom_sys_leader(Y) "IZ"         
      	}
   }

  if {$mom_arc_direction == "CLW"} {
  	#-
     		set mom_arc_angle [ expr  (-1.0)*abs($mom_arc_angle) ]
     		MOM_do_template helix_end_cw
  } elseif {$mom_arc_direction == "CCLW" } {
  	#+
    		set mom_arc_angle [ expr  abs($mom_arc_angle) ]
    		MOM_do_template helix_end_ccw
  }

  set mom_arc_angle [ expr  abs($mom_arc_angle) ]
  set mom_sys_leader(Circle_angle) "PA"
  set mom_sys_leader(X) "X"
  set mom_sys_leader(Y) "Y"
  set mom_sys_leader(Z) "Z"

}

#=============================================================
proc PB_CMD_set_csys { } {
#=============================================================
# This custom command is provided as the default to nullify
# the same command in a linked post that may have been
# imported from pb_cmd_coordinate_system_rotation.tcl.
#
}
##################################################################################################


#=============================================================
proc PB_CMD_cycle_init { } {
#=============================================================
  global cycle_name ;
  global cycle_init_flag ;

	global mom_motion_event
	global mom_tool_diameter
	global mom_pos mom_prev_pos
	global mom_alt_pos  mom_prev_alt_pos
	global mom_cycle_delay  mom_cycle_delay_revs  mom_cycle_delay_mode
 	global mom_cycle_step1 mom_cycle_step2  mom_cycle_step3
  	global mom_cycle_feed_to mom_cycle_feed_to_pos
	global mom_cycle_retract_mode  mom_cycle_retract_to
	global mom_cycle_clearance_plane
	global mom_cycle_cam

  	global dwell_at_top
  	global surface_coordinate
  	global depth_bottom
  	global step1  step2  step3

  global cycle_step ;

  #   
  if {$mom_prev_alt_pos(2)!=$mom_alt_pos(2)} { set  cycle_step  0; }

  if {$cycle_step==0} {

  	set surface_coordinate  $mom_alt_pos(2)
	set depth_bottom  [ expr $mom_cycle_feed_to_pos(2) - $mom_alt_pos(2) ]
  	set dwell_at_top  0.0
	set step1  $mom_cycle_step1
	if {$step1==0.0} { set step1 [ expr abs($depth_bottom) ] ; }

	switch $cycle_name {

	 DRILL {

 	MOM_force once Q200 Q201 Q206 Q202 Q210 Q203 Q204
 	MOM_suppress Always  Q211

 	MOM_do_template cycle_200_drill

  	# MOM_do_template cycle_200
  	# MOM_suppress always N
  	# MOM_do_template tnc_q200 ; # 1-  
  	# MOM_do_template tnc_q201 ; # 
  	# MOM_do_template tnc_q206 ; #    
  	# MOM_do_template tnc_q202 ; # 
  	# MOM_do_template tnc_q210 ; #    
  	# MOM_do_template tnc_q203 ; #  
 	# MOM_do_template tnc_q204 ; # 2-  
	# MOM_suppress off    N

	}

	DRILL_DWELL {

  	MOM_force once Q200 Q201 Q206 Q202 Q210 Q203 Q204 Q211

  	MOM_do_template cycle_200_drill

  	# MOM_do_template cycle_200
  	# MOM_suppress always N
  	# MOM_do_template tnc_q200 ; # 1-  
  	# MOM_do_template tnc_q201 ; # 
  	# MOM_do_template tnc_q206 ; #    
  	# MOM_do_template tnc_q202 ; # 
  	# MOM_do_template tnc_q210 ; #    
  	# MOM_do_template tnc_q203 ; #  
 	# MOM_do_template tnc_q204 ; # 2-  
  	# MOM_do_template tnc_q211 ; #    
	# MOM_suppress off   N
	}

	DRILL_DEEP {

	MOM_force once Q200 Q201 Q206 Q202 Q210 Q203 Q204 Q211 Q212 Q213 Q205 Q208 Q256

	set step1  $mom_cycle_step1
	set step2  $mom_cycle_step2
	set step3  $mom_cycle_step3
	if {$step1==0.0} {
	  set step1 $mom_tool_diameter ;
	  set step2 0.0 ;
	 } else {
 	     if {$step2<0.0} {
 	        set step2 [ expr abs($step2) ] ;
 	      } else {
 	     	if {$step2<=$step1} { set step2 [ expr $step1 - $step2 ] ; }
 	     	}
 	  }
	if {$step3==0.0} { set mom_cycle_cam 0 ; }
        if {$mom_cycle_cam==0} { set  step3 0.0 ;  }

	MOM_do_template cycle_203_drill_deep

	#if {$mom_cycle_delay==0.0} { MOM_suppress Always Q211 ; }

  	#MOM_do_template cycle_203
  	#MOM_suppress always N
  	#MOM_do_template tnc_q200 ; # 1-  
  	#MOM_do_template tnc_q201 ; # 
  	#MOM_do_template tnc_q206 ; #    
  	#MOM_do_template tnc_q202 ; #  
  	#MOM_do_template tnc_q210 ; #    
  	#MOM_do_template tnc_q203 ; #  
 	#MOM_do_template tnc_q204 ; # 2-  
 	#MOM_do_template tnc_q212 ; #    
  	#MOM_do_template tnc_q213 ; #   
  	#MOM_do_template tnc_q205 ; # .  
  	#MOM_do_template tnc_q211 ; #    
  	#MOM_do_template tnc_q208 ; #      
	#MOM_force once Q256
  	#MOM_do_template tnc_q256 ; #     
  	#MOM_suppress off    N
	}

	DRILL_BREAK_CHIP {

   	MOM_force once Q200 Q201 Q206 Q202 Q210 Q203 Q204 Q211 Q212 Q213 Q205 Q208 Q256

	set step1  $mom_cycle_step1
	set step2  $mom_cycle_step2
	set step3  $mom_cycle_step3
	if {$step1==0.0} {
	  set step1 $mom_tool_diameter ;
	  set step2 0.0 ;
	 } else {
 	     if {$step2<0.0} {
 	        set step2 [ expr abs($step2) ] ;
 	      } else {
 	     	if {$step2<=$step1} { set step2 [ expr $step1 - $step2 ] ; }
 	     	}
 	  }
	if {$step3==0.0} { set mom_cycle_cam 0 ; }
        if {$mom_cycle_cam==0} { set  step3 0.0 ;  }

	MOM_do_template cycle_203_drill_deep

  	#MOM_do_template cycle_203
  	#MOM_suppress always N
  	#MOM_do_template tnc_q200 ; # 1-  
  	#MOM_do_template tnc_q201 ; # 
  	#MOM_do_template tnc_q206 ; #    
  	#MOM_do_template tnc_q202 ; #  
  	#MOM_do_template tnc_q202_1 ; #  
  	#MOM_do_template tnc_q210 ; #    
  	#MOM_do_template tnc_q203 ; #  
  	#MOM_do_template tnc_q208 ; #
 	#MOM_do_template tnc_q204 ; # 2-  
 	#MOM_do_template tnc_q212 ; #    
	#set mom_cycle_cam $mom_cycle_cam
  	#MOM_do_template tnc_q213 ; #   
  	#MOM_do_template tnc_q205 ; # .  
  	#MOM_do_template tnc_q211 ; #    
  	#MOM_do_template tnc_q208 ; #      
	#MOM_force once Q256
  	#MOM_do_template tnc_q256 ; #     
  	#MOM_do_template tnc_q257 ; #    
  	#MOM_suppress off    N

	}

	TAP {

	MOM_force once Q200 Q201 Q239 Q203 Q204 Q211

 	MOM_do_template cycle_207_tap

  	#MOM_do_template cycle_203
  	#MOM_suppress always N
  	#MOM_do_template tnc_q200 ; # 1-  
  	#MOM_do_template tnc_q201 ; # 
  	#MOM_do_template tnc_q202_1 ; # 
  	#MOM_do_template tnc_q203 ; #  
 	#MOM_do_template tnc_q204 ; # 2-  
  	#MOM_suppress off    N

	}

	BORE_DWELL {

   	MOM_force once Q200 Q201 Q206 Q211 Q208 Q203 Q204 Q214 Q336

   	MOM_do_template cycle_202_boring

  	#MOM_do_template cycle_202
  	#MOM_suppress always N
  	#MOM_do_template tnc_q200
  	#MOM_do_template tnc_q201
  	#MOM_do_template tnc_q206
  	#MOM_do_template tnc_q211
  	#MOM_do_template tnc_q208
 	#MOM_do_template tnc_q203
 	#MOM_do_template tnc_q204
	#set mom_cycle_cam $mom_cycle_cam
  	#MOM_do_template tnc_q214
  	#MOM_do_template tnc_q336
  	#MOM_suppress off    N

	}

	BORE {

   	MOM_force once Q200 Q201 Q206 Q211 Q208 Q203 Q204 Q214 Q336

   	MOM_do_template cycle_202_boring

  	#MOM_do_template cycle_202
  	#MOM_suppress always N
  	#MOM_do_template tnc_q200
  	#MOM_do_template tnc_q201
  	#MOM_do_template tnc_q206
  	#MOM_do_template tnc_q208
 	#MOM_do_template tnc_q203
 	#MOM_do_template tnc_q204
	#set mom_cycle_cam $mom_cycle_cam
  	#MOM_do_template tnc_q214
  	#MOM_do_template tnc_q336
  	#MOM_suppress off    N

	}


	default { ; }
	}


  }
  incr cycle_step ;

  	MOM_force once X Y
	MOM_do_template cycle_xy
	#  CYCLE CALL
	# MOM_do_template cycle_call

  return ;
}

#=============================================================
proc  MOM_cycle_plane_change {} {
#        .
#=============================================================
  global cycle_init_flag ;   set cycle_init_flag TRUE

  global mom_pos mom_prev_pos

  if {$mom_pos(2) <= $mom_prev_pos(2) } {
   	MOM_do_template rapid_traverse_xy
   	MOM_do_template rapid_spindle_z
   } else {
   	MOM_do_template rapid_spindle_z
   	MOM_do_template rapid_traverse_xy
    }

#    	global mom_pos mom_prev_pos mom_pos_z mom_prev_pos_z
#
#   	if {$mom_pos_z < $mom_prev_pos_z } {
#  		MOM_do_template rapid_cycle_bc
#   		MOM_do_template rapid_cycle_xy
#   		MOM_do_template rapid_cycle_z
#   	} else {
#   		MOM_do_template rapid_cycle_z
#   		MOM_do_template rapid_cycle_bc
#   		MOM_do_template rapid_cycle_xy
#   	}
#  	MOM_do_template cycle_call
#  	set mom_prev_pos_z $mom_pos_z

}


#=============================================================
proc MOM_drill { } {
#       .
#=============================================================

  global cycle_name ;
  global cycle_init_flag ;

  set cycle_name DRILL
  set cycle_init_flag TRUE

  global cycle_step ; set  cycle_step 0 ; #  

}


#=============================================================
proc  MOM_drill_move { } {
#         .
#=============================================================
	global  cycle_init_flag
	PB_CMD_cycle_init
	set cycle_init_flag FALSE
}


#=============================================================
proc MOM_drill_dwell { } {
#         .
#=============================================================

  global cycle_name ;
  global cycle_init_flag ;

  set cycle_name DRILL_DWELL
  set cycle_init_flag TRUE

  global cycle_step ; set  cycle_step 0 ; #  

}


#=============================================================
proc  MOM_drill_dwell_move { } {
#           .
#=============================================================
	global  cycle_init_flag
	PB_CMD_cycle_init
	set cycle_init_flag FALSE
}


#=============================================================
proc MOM_drill_deep { } {
#        .
#=============================================================

  global cycle_name ;
  global cycle_init_flag ;

  set cycle_name DRILL_DEEP
  set cycle_init_flag TRUE

  global cycle_step ; set  cycle_step 0 ; #  

}


#=============================================================
proc  MOM_drill_deep_move { } {
#        
#  .
#=============================================================
	global  cycle_init_flag
	PB_CMD_cycle_init
	set cycle_init_flag FALSE
}


#=============================================================
proc MOM_drill_break_chip { } {
#        
#  .
#=============================================================
  global cycle_name ;
  global cycle_init_flag ;

  set cycle_name DRILL_BREAK_CHIP
  set cycle_init_flag TRUE

  global cycle_step ; set  cycle_step 0 ;

}


#=============================================================
proc  MOM_drill_break_chip_move { } {
#       
#     .
#=============================================================
	global  cycle_init_flag
	PB_CMD_cycle_init
	set cycle_init_flag FALSE

}


#=============================================================
proc MOM_tap { } {
#        .
#=============================================================
  global cycle_name
  global cycle_init_flag

  set cycle_init_flag TRUE
  set cycle_name TAP

  global cycle_step ; set  cycle_step 0 ; #  

}


#=============================================================
proc  MOM_tap_move { } {
#       
#   .
#=============================================================
	global  cycle_init_flag
	PB_CMD_cycle_init
	set cycle_init_flag FALSE
}


#=============================================================
proc MOM_bore { } {
#       .
#=============================================================
  global cycle_name ;
  global cycle_init_flag ;

  set cycle_name BORE
  set cycle_init_flag TRUE

  global cycle_step ; set  cycle_step 0 ; #  

}


#=============================================================
proc  MOM_bore_move { } {
#       
#  .
#=============================================================
	global  cycle_init_flag
	PB_CMD_cycle_init
	set cycle_init_flag FALSE
}


#=============================================================
proc MOM_bore_drag { } {
#       .
#=============================================================

	global mom_warning_info
	set mom_warning_info " MOM_bore_drag  "
        MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
        return ;

  global cycle_name ;
  global cycle_init_flag ;

  set cycle_name BORE_DRAG
  set cycle_init_flag TRUE

  global cycle_step ; set  cycle_step 0 ; #  
}


#=============================================================
proc  MOM_bore_drag_move { } {
#       
#  .
#=============================================================

	global mom_warning_info
	set mom_warning_info " MOM_bore_drag  "
        MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
        return ;

	global  cycle_init_flag
	PB_CMD_cycle_init
	set cycle_init_flag FALSE
}


#=============================================================
proc MOM_bore_no_drag { } {
#      
#    .
#=============================================================

	global mom_warning_info
	set mom_warning_info " MOM_bore_no_drag  "
        MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
        return ;

  global cycle_name ;
  global cycle_init_flag ;

  set cycle_name BORE_NO_DRAG
  set cycle_init_flag TRUE

  global cycle_step ; set  cycle_step 0 ; #  
}


#=============================================================
proc  MOM_bore_no_drag_move { } {
#        
#    .
#=============================================================

	global mom_warning_info
	set mom_warning_info " MOM_bore_no_drag  "
        MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
        return ;

	global  cycle_init_flag
	PB_CMD_cycle_init
	set cycle_init_flag FALSE

}


#=============================================================
proc MOM_bore_manual { } {
#      
#    .
#=============================================================

	global mom_warning_info
	set mom_warning_info " MOM_bore_manual  "
        MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
        return ;

}


#=============================================================
proc  MOM_bore_manual_move { } {
#        
#    .
#=============================================================

	global mom_warning_info
	set mom_warning_info " MOM_bore_manual  "
        MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
        return ;

}


#=============================================================
proc MOM_bore_dwell { } {
#         .
#=============================================================
  global cycle_name
  global cycle_init_flag

  set cycle_init_flag TRUE
  set cycle_name BORE_DWELL

  global cycle_step ; set  cycle_step 0 ; #  

}


#=============================================================
proc  MOM_bore_dwell_move { } {
#        
#   .
#=============================================================
	global  cycle_init_flag
	PB_CMD_cycle_init
	set cycle_init_flag FALSE
}


#=============================================================
proc MOM_bore_back { } {
#        .
#=============================================================

	global mom_warning_info
	set mom_warning_info " MOM_bore_back  "
        MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
        return ;

  global cycle_name ;
  global cycle_init_flag ;

  set cycle_name BORE_BACK
  set cycle_init_flag TRUE

  global cycle_step ; set  cycle_step 0 ; #  
}


#=============================================================
proc  MOM_bore_back_move { } {
#        
#  .
#=============================================================

 	global mom_warning_info
	set mom_warning_info " MOM_bore_back  "
        MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
        return ;

	global  cycle_init_flag
	PB_CMD_cycle_init
	set cycle_init_flag FALSE

}


#=============================================================
proc MOM_bore_manual_dwell { } {
#        
#    .
#=============================================================

	global mom_warning_info
	set mom_warning_info " MOM_bore_manual_dwell  "
        MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
        return ;

}


#=============================================================
proc  MOM_bore_manual_dwell_move { } {
#        
#      .
#=============================================================

	global mom_warning_info
	set mom_warning_info " MOM_bore_manual_dwell  "
        MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
        return ;

}


#=============================================================
proc  MOM_drill_counter_sink {} {
#       Standart Drill - Counter Sink.
#=============================================================
	MOM_drill
}


#=============================================================
proc  MOM_drill_counter_sink_move {} {
#       
# Standart Drill - Counter Sink.
#=============================================================
	MOM_drill_move
}


#=============================================================
proc  MOM_drill_csink_dwell {} {
#      
# Standart Drill - Counter Sink Dwell.
#=============================================================
	MOM_drill_dwell
}


#=============================================================
proc  MOM_drill_csink_dwell_move {} {
#       
# Standart Drill - Counter Sink.
#=============================================================
	MOM_drill_dwell_move
}

######################################################################################################

#=============================================================
proc  MOM_load_tool {} {
#       LOAD/TOOL.  
#       MOM_msys.
#=============================================================

}


#=============================================================
proc  MOM_sequence_number {} {
#      Sequence Number.
#=============================================================
    SEQNO_SET
}


#=============================================================
proc  MOM_set_modes {} {
#       Set Mode.
#=============================================================
	global mom_output_mode
	global mom_arc_mode
	global mom_feed_rate_output_mode
	global mom_parallel_to_axis
	global mom_machine_mode
	global mom_modes_text
	global g_output_mode

# "ABSOLUTE", "INCREMENTAL"
	if {$mom_output_mode == "ABSOLUTE"} {
		set g_output_mode "G90"
		MOM_incremental OFF X Y Z Axis_4th Axis_5th
	} elseif {$mom_output_mode == "INCREMENTAL"} {
		set g_output_mode "G91"
		MOM_incremental ON X Y Z Axis_4th Axis_5th
	}
# "LINEAR", "CIRCULAR"
	if {$mom_arc_mode == "LINEAR"} {
	} elseif {$mom_arc_mode == "CIRCULAR"} {
	}
# "OFF", "IPM", "IPR", "MMPM", "MMPR", "INVERSE"
	if {$mom_feed_rate_output_mode == "FPM"} {
	} elseif {$mom_feed_rate_output_mode == "FPR"} {
	} elseif {$mom_feed_rate_output_mode == "INVERSE"} {
	} elseif {$mom_feed_rate_output_mode == "OFF"} {
	}
# "ZAXIS", "WAXIS", "UAXIS"
	if {$mom_parallel_to_axis == "ZAXIS"} {
	} elseif {$mom_parallel_to_axis == "WAXIS"} {
	} elseif {$mom_parallel_to_axis == "UAXIS"} {
	}
# "MILL", "TURN", "PUNCH", "LASER", "TORCH", "WIRE"
	if {$mom_machine_mode == "MILL"} {
	} elseif {$mom_machine_mode == "TURN"} {
	} elseif {$mom_machine_mode == "PUNCH"} {
	} elseif {$mom_machine_mode == "LASER"} {
	} elseif {$mom_machine_mode == "TORCH"} {
	} elseif {$mom_machine_mode == "WIRE"} {
	}
}


#=============================================================
proc MOM_cutcom_on { } {
#       CUTCOM/ON
#=============================================================
  global mom_cutcom_mode mom_cutcom_status
  global mom_cutcom_adjust_register_defined  mom_cutcom_adjust_register
  global cutcom_mode code_cutcom cutcom_on

proc outCutcom { } {
 global mom_tool_number
 global cutcom_mode code_cutcom cutcom_on
 global mom_cutcom_adjust_register_defined  mom_cutcom_adjust_register

 if { $mom_cutcom_adjust_register_defined!=0} {
	set line_tool [format "TOOL CALL %d.%d Z" $mom_tool_number $mom_cutcom_adjust_register ]
	MOM_output_literal "$line_tool"
    	set   code_cutcom  1
 }
 if { $mom_cutcom_adjust_register_defined==0 && $code_cutcom==1 } {
	set line_tool [format "TOOL CALL %d Z" $mom_tool_number ]
	MOM_output_literal "$line_tool"
 }

}

    switch $mom_cutcom_mode {
    	"OFF" {
         	set cutcom_mode "0"
		#set mom_cutcom_adjust_register  0
	}
	"RIGHT" {
	     outCutcom
       	     set cutcom_mode "R"
      	}
      	"LEFT" {
      	     outCutcom
  	     set cutcom_mode "L"
      	}
      	default { set cutcom_mode "R" ; }
   }

   if {$mom_cutcom_status == "OFF"} {
   	set cutcom_mode "0"
	#set  mom_cutcom_adjust_register  0
    }

   set cutcom_on 1
}


#=============================================================
proc MOM_cutcom_off { } {
#       CUTCOM/OFF
#=============================================================
	global cutcom_mode cutcom_on
	set cutcom_mode "0"
	set cutcom_on 0
		  		MOM_force once X Y
	MOM_force once R
}


#=============================================================
proc MOM_spindle_rpm { } {
#       SPLIND/RPM
#=============================================================
	global mom_tool_number mom_spindle_speed mom_contact_status
	global mom_spindle_speed mom_operation_type mom_operation_name
	global mom_tool_name mom_tool_diameter mom_tool_corner1_radius status_block_create
	global spindle_off_flag  line status_tool_change line_tool mom_output_vectors_on
	global mom_imported_path_status out_m128

#         
#       iTNC-530
	if {$status_block_create == "0"} {
		MOM_block_create
#		MOM_output_literal "L M129"
	}

	if {$mom_tool_number == 0} {
  		if {[info exists mom_imported_path_status]==1} {
    			if {"NO"==[string toupper "$mom_imported_path_status"]} {
				MOM_abort "\n\nError!\n\t      0   $mom_operation_name.\n\n"
			}
		}
    	}

	if {$status_tool_change == 0} {
#    set  out_m128  129
#MOM_do_template outM128
		if {$mom_contact_status == "ON" || $mom_output_vectors_on == "ON"} {
			set line_tool [format "TOOL CALL %d Z S%.0f DL=0.0 DR=0.0 DR2=0.0" $mom_tool_number $mom_spindle_speed]
			MOM_output_literal "$line_tool"
			set line [format "; TOOL: %s D=%.2f " $mom_tool_name $mom_tool_diameter ]
			if {[info exists mom_tool_corner1_radius]} {
				append line [format "R=%.2f" $mom_tool_corner1_radius ]
			}
   			MOM_output_literal "$line"
   			MOM_output_literal "; POSITIVE VALUES DL, DR, DR2 MEAN THAT THE SIZE MORE ORIGINAL"
			MOM_output_literal "; NEGATIVE VALUES DL, DR, DR2 MEAN THAT THE SIZE LESS ORIGINAL"
			MOM_output_literal "; WARNING: IN 3D CUTTER COMPENSATION MODE"
			MOM_output_literal "; USE THE TOOL OF GREATER DIAMETER MAY GOUGED OF THE PART !!!"
		} else {
			set line_tool [format "TOOL CALL %d Z S%.0f" $mom_tool_number $mom_spindle_speed]
			MOM_output_literal "$line_tool"
				        if {[info exists mom_imported_path_status]==1} {
                          if {"YES"==[string toupper "$mom_imported_path_status"]} {
                               set mom_warning_info "WARNING: =$mom_operation_name -   ( -   !)"
                            } else {
      	set line [format "; TOOL: %s D=%.2f " $mom_tool_name $mom_tool_diameter ]
			if {[info exists mom_tool_corner1_radius]} {
				append line [format "R=%.2f" $mom_tool_corner1_radius ]
			}
   			MOM_output_literal "$line"
                          }
                          #MOM_reload_kinematics
                         }

		}

		if {$mom_spindle_speed == 0.0} {
  			if {[info exists mom_imported_path_status]==1} {
    				if {"NO"==[string toupper "$mom_imported_path_status"]} {
					MOM_abort "\n\nError!\n\t      0   $mom_operation_name .\n\n"
				}
			}
		}
   		MOM_do_template spindle_rpm
   		set spindle_off_flag 1
   		set status_tool_change 1
   	} else {
   		   MOM_do_template tool_call_s
   		if {$spindle_off_flag == 0}	{
	                MOM_force once M_spindle F
   			MOM_do_template spindle_rpm
   			set spindle_off_flag 1
		}
      }
	if {$mom_operation_type == "Variable-axis Surface Contouring"	||
		$mom_operation_type == "Sequential Mill Main Operation"	||
		$mom_operation_type == "Zig-Zag Surface" } {
		#MOM_output_literal "L M126"
	}
}


#=============================================================
proc  MOM_spindle_off {} {
#       SPLIND/OFF.
#=============================================================
	global spindle_off_flag

         MOM_do_template spindle_off
         set spindle_off_flag 0
}


#=============================================================
proc  MOM_coolant_on {} {
#       COOLANT/ON.
#=============================================================
	COOLANT_SET
	MOM_force Once M_coolant
	MOM_do_template coolant_on
}


#=============================================================
proc  MOM_coolant_off {} {
#       COOLANT/OFF.
#=============================================================
	COOLANT_SET
	MOM_do_template coolant_off
}


#=============================================================
proc  MOM_opstop {} {
#       OPTIONAL STOP.
#=============================================================
	MOM_do_template opstop
}


#=============================================================
proc  MOM_stop {} {
#       PROGRAM STOP.
#=============================================================
	MOM_do_template stop
}


#=============================================================
proc  MOM_opskip_on {} {
#       OPTIONAL SKIP/ON.
#=============================================================
	MOM_set_line_leader always "/"
}


#=============================================================
proc  MOM_opskip_off {} {
#       OPTIONAL SKIP/OFF.
#=============================================================
	MOM_set_line_leader off "/"
}


#=============================================================
proc  MOM_delay {} {
#       DELAY.
#=============================================================
	global mom_delay_value

	MOM_do_template delay_1
	MOM_do_template delay_2
}


#=============================================================
proc  MOM_auxfun {} {
#      
# AUXILIARY FUNCTION.
#=============================================================
	MOM_do_template auxiliary
}


#=============================================================
proc  MOM_prefun {} {
#      
# PREPARATORY FUNCTION.
#=============================================================
	MOM_do_template preparatory
}


#=============================================================
proc  MOM_length_compensation {} {
#      
# TOOL LENGTH COMPENSATION.
#=============================================================
}


#=============================================================
proc  MOM_tool_preselect {} {
#       TEXT.
#=============================================================
}


#=============================================================
proc MOM_zero {} {
#        ZERO
#=============================================================
	global mom_work_coordinate_number zero_point
	
	  MOM_output_literal "CYCL DEF 247 DATUM SETTING Q339=+$mom_work_coordinate_number;  DATUM NUMBER"
	#MOM_output_literal "CYCL DEF 247 DATUM SETTING"
	#MOM_output_literal "Q339=+1;  DATUM NUMBER"
#	MOM_output_literal "CYCL DEF 7.2 Y0.0"
#	MOM_output_literal "CYCL DEF 7.3 Z0.0"
#	MOM_output_literal "; SET NULL POINT SHIFT"
 set zero_point 1
			MOM_force once  X Y Z


}


#=============================================================
proc  MOM_text {} {
#        .
#=============================================================
	global mom_user_defined_text
	global mom_record_fields
	global mom_record_text
	global MCSROT_mode
	global MCSROT_flag
	global is_MCSROT_matrix_set
	global first_move_after_MCSROT
	global prog_number mom_work_coordinate_number

	switch $mom_record_fields(0) {
	"INSERT"
	{
		MOM_output_literal $mom_record_text
	}
	"ZERO"
	{
		set mom_work_coordinate_number $mom_record_fields(1)
		MOM_zero
	}
	"MCSROT"
	{
		set MCSROT_mode $mom_record_fields(1)
		if {$mom_record_fields(1) == "OFF"} {
			set MCSROT_flag 0
			set is_MCSROT_matrix_set 0
			set first_move_after_MCSROT 0
			MOM_suppress off K
			MOM_do_template cancel_rotate_mcs
		} else {
			set MCSROT_flag 1
		}
	}
	"PARTNO"
	{
		set mom_record_text [string trim $mom_record_text " "]
		set temp [split $mom_record_text " "]
		set prog_number [lindex $temp 0]
		PROGRAM_START
	}
	default
		{ MOM_output_literal "$mom_user_defined_text" }
	}
}

#=============================================================
proc MOM_cycle_19 { } {
#       
#=============================================================
	global mom_cycle_19_on_off mom_event_handler_file_name 
	global mom_kin_4th_axis_min_limit mom_kin_4th_axis_plane mom_kin_4th_axis_type 
	global mom_kin_5th_axis_zero mom_kin_5th_axis_plane
	global mom_kin_5th_axis_type mom_kin_machine_type mom_load_event_handler
	global mom_kin_5th_axis_inclination_to_4th cycle_19_on
	
	   	    global strDir
    
      set strDir [file dirname $mom_event_handler_file_name]
      if {[regsub -all -nocase -- {(/)} $strDir "\\" var0]} { set strDir $var0 }
    
       if {$mom_cycle_19_on_off == "ON"} {
       	      set cycle_19_on  1
	#        set mom_kin_4th_axis_min_limit		0.000	        
	        set mom_kin_machine_type			5_axis_dual_table 	
       	  set mom_kin_4th_axis_plane			YZ
       	  set mom_kin_4th_axis_type                     "Table" 
       	  set mom_kin_5th_axis_type                   "Table"
	        set mom_kin_5th_axis_plane			XY 
	        
	
      MOM_load_definition_file  ${strDir}\\udmu40_monoBLOCK.def
      MOM_reload_kinematics
     }
   if {$mom_cycle_19_on_off == "OFF"} {
   	 set cycle_19_on  0
   #		        set mom_kin_4th_axis_min_limit		0.000	        
	        set mom_kin_machine_type			5_axis_head_table 	
       	  set mom_kin_4th_axis_plane			YZ
       	  set mom_kin_4th_axis_type                     "Head" 
       	  set mom_kin_5th_axis_type                     "Table"
	        set mom_kin_5th_axis_plane			XY     	        
       	               
      MOM_load_definition_file  ${strDir}\\dmu40_monoBLOCK.def
      MOM_reload_kinematics
          	 MOM_do_template from_move_M91_1
   	         MOM_do_template from_move_M91_2
    
			set rot_table_1 [format "CYCL DEF 19.0 WORKING PLANE"]
	    set rot_table_2 [format "CYCL DEF 19.1 " ]
	    set rot_table_3 [format "CYCL DEF 19.1 A0 B0 C0 F2000 " ]
	#    	MOM_force once Axis_4th Axis_5th

	        MOM_output_literal "$rot_table_1"
	        MOM_output_literal "$rot_table_3"
	        	        MOM_do_template rotate_bcq
	        MOM_output_literal "$rot_table_1"
	        MOM_output_literal "$rot_table_2"        
	        	        	        	        
		}
  	 
}
#=============================================================
proc MOM_before_motion {} {
#        .
#=============================================================
   global mom_motion_type
   FEEDRATE_SET

    switch $mom_motion_type {
      ENGAGE   {PB_engage_move}
      APPROACH {PB_approach_move}
      FIRSTCUT {PB_first_cut}
    }


    if { [llength [info commands PB_CMD_kin_before_motion]] } { PB_CMD_kin_before_motion }
    if { [llength [info commands PB_CMD_before_motion]] }     { PB_CMD_before_motion }

}


#=============================================================
proc PB_CMD_kin_before_motion { } {
#=============================================================
#
#  This custom command is used by UG Post to support Set/Lock,
#  rotary axis limit violation retracts and auto clamping.
#  Do not change this procedure.  If you want to improve
#  performance, you may comment out any of these procedures.
#

   global mom_kin_machine_type

   LOCK_AXIS_MOTION

  # ROTARY_AXIS_RETRACT

   AUTO_CLAMP
}
#=============================================================
proc PB_CMD_before_motion { } {
#=============================================================
  global mom_current_motion  mom_motion_event  mom_motion_type  mom_operation_type
  global mom_tool_axis mom_prev_tool_axis mom_operation_name
  global mom_mcs_goto mom_prev_mcs_goto
  global mom_pos mom_alt_pos mom_out_angle_pos
  global mom_clearance_plane_point mom_clearance_plane_status
  global mom_feed_rate  mom_motion_distance
  global mom_nxt_motion_type mom_nxt_motion_event  mom_nxt_pos
  global out_m128 nn mom_pos_a1 mom_alt_pos_a1 mom_rotation_angle
  global mom_machine_time_dmu_1 mom_machine_time_dmu
  global leader_4th leader_5th mom_cycle_19_on_off mom_pos_arc_plane mom_sys_leader
    global prev_c_value theta_value prev_theta_value c_value
  set leader_4th "B"
  set leader_5th "C"
   
#       DMU

    set   n1 [ expr ($mom_mcs_goto(0)-$mom_prev_mcs_goto(0) )]
    set   n2 [ expr ($mom_mcs_goto(1)-$mom_prev_mcs_goto(1) )]
    set   n3 [ expr ($mom_mcs_goto(2)-$mom_prev_mcs_goto(2) )]
#   MOM_output_literal "NXT = $mom_motion_event"

     set  n4 [ expr (sqrt($n1*$n1+$n2*$n2+$n3*$n3)/$mom_feed_rate)]
    set  n5 [ expr ( $mom_motion_distance /$mom_feed_rate)]
    set  n6 [ expr (sqrt( ($n3*$n3) + ($mom_motion_distance*$mom_motion_distance)  ) /$mom_feed_rate  ) ]
    if {$mom_motion_event=="circular_move" } {
          set mom_machine_time_dmu_1  [ expr ( $mom_machine_time_dmu_1 + $n5 )]
     } else {
     	 if {$mom_motion_event=="helix_move" } {
     	 	set mom_machine_time_dmu_1  [ expr ( $mom_machine_time_dmu_1 + $n6 )]
     	 	
     	 	
     	} else {
      set mom_machine_time_dmu  [ expr ( $mom_machine_time_dmu + $n4 )]
      set mom_machine_time_dmu_1  [ expr ( $mom_machine_time_dmu_1 + $n4 )]
    }
  }
    
    set i [format "%-.6f" $mom_tool_axis(0)]
    set j [format "%-.6f" $mom_tool_axis(1)]
    set k [format "%-.6f" $mom_tool_axis(2)]

    set i1 [format "%-.6f" $mom_prev_tool_axis(0)]
    set j1 [format "%-.6f" $mom_prev_tool_axis(1)]
    set k1 [format "%-.6f" $mom_prev_tool_axis(2)]

    if {$i=="0.0" && $j=="0.0" &&  ($k=="1.0" || $k=="-1.0" ) } {
   } else {
   	if { $mom_rotation_angle!=0.0} {
   	MOM_abort "   $mom_operation_name    ROTATE!!!!!"
  }}
     if {$i=="0.0" && $j=="0.0" &&  ($k=="1.0" || $k=="-1.0" ) && $mom_rotation_angle==0.0} {
		    set  out_m128  129
		set mom_out_angle_pos(1) 0

#		set c_value 0
# return;
   } else {
   	    if {$mom_cycle_19_on_off == "OFF"  } {
   	    	   set out_m128  128
   } else {
                 set  out_m128  129
                }
     if {$mom_motion_event=="circular_move" && $mom_rotation_angle==0.0 && \
     	$mom_cycle_19_on_off == "OFF"} {		MOM_abort "       !!!!!"}
                }
                
               
                	
                if {$i=="0.0" && $j=="0.0" && ( $k=="1.0" || $k=="-1.0" ) && $mom_rotation_angle!=0.0 } {
  if {$mom_motion_event!="from_move"&&$mom_motion_event!="initial_move"&&$mom_motion_event!="gohome_move"} {
  	 	set c_adr $mom_out_angle_pos(1)
 	
			if { ($c_adr>=360 ||$c_adr<=-360) } {
   		MOM_do_template gohome_ac
   	}
  }
                            
  }

  if {$i=="0.0" && $j=="0.0" && ( $k=="1.0" || $k=="-1.0" ) && $mom_rotation_angle==0.0 } {
  
  	if {$mom_motion_event!="from_move"&&$mom_motion_event!="initial_move"&&$mom_motion_event!="gohome_move"} {
  		set c_adr $mom_out_angle_pos(1)
   
			if { ($c_adr>=360 ||$c_adr<=-360) } {
   		MOM_do_template gohome_ac
   	}
  }
                             
  }
   			
		
  	  if {$mom_cycle_19_on_off == "ON"} {
		      		    
		      	MOM_suppress once Axis_4th Axis_5th 
		      	  
		  } 
#            (+-30000 ).

    
   PB_limit_angle

}

#=============================================================
proc SET_ROTARY_ANGLE {v1} {
#       .
#=============================================================
	global prev_c_value
	global prev_theta_value

	set angle $v1
	set diff [expr $angle - $prev_theta_value]

	if {[EQ_is_zero $diff]} {
		set direction 0
	} elseif {abs($diff) <= 180} {
		if {$angle > $prev_theta_value} {
			set direction -1
		} else {
			set direction 1
		}
	} else {
		if {$angle > $prev_theta_value} {
			set direction 1
		} else {
			set direction -1
		}
	}

	if {$direction == 1} {
		if {$angle >= $prev_c_value} {
			while {$angle > $prev_c_value} {
				set angle [expr $angle - 360]
			}
		} else {
			while {$angle < $prev_c_value} {
				set angle [expr $angle + 360]
			}
			set angle [expr $angle - 360.0]
		}
	} elseif {$direction == -1} {
		if {$angle <= $prev_c_value} {
				while {$angle < $prev_c_value} {
				set angle [expr $angle + 360]
			}
		} else {
			while {$angle > $prev_c_value} {
				set angle [expr $angle - 360]
			}
			set angle [expr $angle + 360.0]
		}
	} else {
		set angle $prev_c_value
	}
#    MOM_output_literal "NXT999999999999999= $angle"
	return $angle
}

#=============================================================
proc PB_limit_angle {} {
#      .
#=============================================================
 global mom_warning_info  mom_seqnum
 global nn warning_1
 if {$mom_warning_info== "unable to determine valid rotary positions"} {
    incr nn
    set warning_1($nn) [format "; :   %.0f  B    -120" $mom_seqnum ]
    set mom_warning_info ""
  }
}


#=============================================================
proc PB_approach_move { } {
#=============================================================
}


#=============================================================
proc PB_engage_move { } {
#=============================================================
}


#=============================================================
proc PB_first_cut { } {
#=============================================================
}


#=============================================================
proc PB_first_linear_move { } {
#=============================================================
}


#=============================================================
proc PB_return_move { } {
#=============================================================
}


#=============================================================
proc MOM_machine_mode {} {
#      .
#=============================================================
	MOM_start_of_group
}


######################################################################################################


#=============================================================
proc MOM_smooth_tool_path { } {
#      .
#=============================================================
	global mom_smooth_path
}


#=============================================================
proc MOM_tolerance_cycle { } {
#       
#=============================================================
	global mom_tolerance_on_off
	global mom_operation_type
	global mom_inside_outside_tolerances
	global tolerances
	global temp mom_tolerance

	MOM_force once Tol

  	if {$mom_operation_type == "Variable-axis Surface Contouring"  	|| \
		$mom_operation_type == "Cavity Milling" 		|| \
		$mom_operation_type == "Fixed-axis Surface Contouring"  || \
		$mom_operation_type == "Planar Milling"  		|| \
		$mom_operation_type == "Sequential Mill Main Operation" || \
		$mom_operation_type == "Zig-Zag Surface" } {
  		set temp [expr $mom_inside_outside_tolerances(0) + $mom_inside_outside_tolerances(1)]
 		set tolerances [expr $temp/2]
#       set tolerances  $mom_tolerance
       set   mom_tolerance_on_off   "ON"
  	}
}

#=============================================================
proc MOM_spindle_orient { } {
#      .
#=============================================================
	global mom_angle_orient
	MOM_force once Angle
	MOM_do_template spindle_orient_1
	MOM_do_template spindle_orient_2
}


proc COUNT_alk {x y alk} {
#_______________________________________________________________________________
# This procedure is executed for  ygol  megdy  vectorom i X
#_______________________________________________________________________________
	   set pi 3.1415927
       if {$x == 0. && $y==0.} {
	       set alk [expr (3.*$pi/2.)]
	       return $alk
	       }
      if {$x < 0.} {
	       set alk [expr ($pi + atan($y/$x))]
	       return $alk
	       }
      if {$x == 0.} {
	    if {$y > 0.} {
	       set alk [expr ($pi/2)]
	       } else {
		set alk [expr (3.*$pi/2.)]
		}
		  return $alk
	       }
       if {$x > 0.} {
	      set alk [expr (atan($y/$x))]
	       if {$alk < 0.} { set alk [expr ($alk+2.*$pi)] }
	       if {$alk == 0.} { set alk 0. }
	       }
	      return $alk
}


#=============================================================
proc LIMIT_ANGLE { a } {
#=============================================================

   while {$a < 0.0} {set a [expr $a+360.0]}
   while {$a >= 360.0} {set a [expr $a-360.0]}

return $a
}


#=============================================================
proc PB_CMD_init_rotary { } {
#=============================================================
uplevel #0 {

#
# Fourth and Fifth Axis Auto Clamping is activated by programming the
# UDE CLAMP/AUTO,ON in your tool path.  Fourth and Fifth Axis Auto
# Clamping may be turned off by programming the UDE CLAMP/AUTO,OFF.
#
# An M10 will be output to clamp the XYZ axis for fourth axis
# motion. An M11 will be output to un-clamp the fourth axis
# when fourth axis motion occurs in the block.  You may edit
# the custom commands PB_CMD_clamp_fourth_axis or
# PB_CMD_unclamp_fourth_axis to output codes other than M10 or M11.
# The same is true for the fifth axis except you must edit the custom
# commands PB_CMD_clamp_fifth_axis or PB_CMD_unclamp_fifth_axis.  If you
# have a five axis machine tool and only want fourth or fifth axis auto
# clamping, you will need to comment out the line that outputs the unneed
# code
#
#
# Retract and Re-Engage Parameters
#
# This option is activated by setting the Axis Limit Violation
# Handling option on the Machine Tool dialog to Retract / Re-Engage.
#
# The sequence of actions that take place when a rotary limit violation
# occurs is a retract to the clearance plane at the rapid feedrate,
# reposition the rotary axes so they do not violate, move back to
# the engage point at the retract feedrate and engage into the part again.
#
# You can set additional parameters that will control the retract
# and re-engage motion.
#
# The parameter "mom_kin_retract_plane" defines the distance
# from the center of rotation that the tool will retract when
# an axis violation occurs.  For a four axis head machine tool the
# retraction will be a cylinder.  For a five axis head machine tool
# the retraction will be to a sphere. For rotary tables the
# retraction will be to a plane along the spindle axis.
#

set mom_kin_retract_plane                      10.0


#
# The parameter "mom_kin_reengage_distance" defines the engage
# point above the part.
#

set mom_kin_reengage_distance                  .1


#
# The following parameters are used by UG Post.  Do NOT change
# them unless you know what you are doing.
#

set mom_kin_spindle_axis(0)                    0.0
set mom_kin_spindle_axis(1)                    0.0
set mom_kin_spindle_axis(2)                    1.0

if [info exists mom_sys_spindle_axis] { unset mom_sys_spindle_axis }

set mom_sys_spindle_axis(0)                    0.0
set mom_sys_spindle_axis(1)                    0.0
set mom_sys_spindle_axis(2)                    1.0

set mom_sys_lock_status                        "OFF"

} ;# uplevel
}

#=============================================================
proc PB_CMD_kin_init_mill_turn { } {
#=============================================================
}


#=============================================================
proc PB_CMD_kin_init_mill_xzc { } {
#=============================================================
}


#=============================================================
proc PB_CMD_kin_init_rotary { } {
#=============================================================

   global mom_kin_machine_type

   if [info exists mom_kin_machine_type] {
      if { [string match "*3_axis_mill*" $mom_kin_machine_type] ||  [string match "*lathe*" $mom_kin_machine_type] } {
return
      }
   }


   PB_CMD_init_rotary



uplevel #0 {


#=============================================================
proc MOM_clamp { } {
#=============================================================
  global mom_clamp_axis mom_clamp_status mom_sys_auto_clamp

   if {$mom_clamp_axis == "AUTO"} {
      if {$mom_clamp_status == "ON"} {
         set mom_sys_auto_clamp "ON"
      } elseif {$mom_clamp_status == "OFF"} {
         set mom_sys_auto_clamp "OFF"
      }
   }
}

#=============================================================
proc MOM_rotate { } {
#=============================================================
  global mom_rotate_axis_type mom_rotation_mode mom_rotation_direction
  global mom_rotation_angle mom_rotation_reference_mode
  global mom_kin_machine_type mom_kin_4th_axis_direction mom_kin_5th_axis_direction
  global mom_kin_4th_axis_leader mom_kin_5th_axis_leader
  global mom_kin_4th_axis_leader mom_kin_5th_axis_leader mom_pos
  global mom_out_angle_pos mom_prev_out_angle_pos
  global unlocked_prev_pos mom_sys_leader
  global mom_kin_4th_axis_min_limit mom_kin_4th_axis_max_limit
  global mom_kin_5th_axis_min_limit mom_kin_5th_axis_max_limit
  global mom_prev_pos out_m128

   if {![info exists mom_rotation_angle]} {return}

  #
  #  Determine which axis the user wanted, fourth or fifth.
  #
   switch $mom_rotate_axis_type {
      AAXIS {
         set axis [AXIS_SET $mom_rotate_axis_type]
      }
      BAXIS {
         set axis [AXIS_SET $mom_rotate_axis_type]
      }
      CAXIS {
      #   set axis [AXIS_SET $mom_rotate_axis_type]
            set axis 4

      }
      TABLE {
         set axis 3
      }
      HEAD {
         if { $mom_kin_machine_type == "5_axis_head_table"  ||  $mom_kin_machine_type == "5_AXIS_HEAD_TABLE" } {
            set axis 3
         } else {
            set axis 3
         }
      }
      default {
         set axis 3
      }
   }
#MOM_output_literal "axis  $axis"
   switch $mom_rotation_mode {
      NONE {
         set angle $mom_rotation_angle
         set mode 0
      }
      ATANGLE {
         set angle $mom_rotation_angle
         set mode 0
      }
      ABSOLUTE {
         set angle $mom_rotation_angle
         set mode 1
      }
      INCREMENTAL {
         set angle [expr $mom_pos($axis) + $mom_rotation_angle]
         set mode 0
      }
   }
#MOM_output_literal "mode  $mode angle $angle"
   switch $mom_rotation_direction {
      NONE {
         set dir 0
      }
      CLW {
         set dir 1
      }
      CCLW {
         set dir -1
      }
   }
#MOM_output_literal "dir  $dir"
   set ang [LIMIT_ANGLE $angle]
   set mom_pos($axis) $ang
#MOM_output_literal "ang   $ang "


   if {$axis == "3" && ![info exists mom_prev_out_angle_pos(0)]} {
      set mom_prev_out_angle_pos(0) [MOM_ask_address_value fourth_axis]
      if {$mom_prev_out_angle_pos(0) == ""} {set mom_prev_out_angle_pos(0) 0.0}
   }


   if {$axis == "4" && ![info exists mom_prev_out_angle_pos(1)]} {
      set mom_prev_out_angle_pos(1) [MOM_ask_address_value fifth_axis]
      if {$mom_prev_out_angle_pos(1) == ""} {set mom_prev_out_angle_pos(1) 0.0}
   }

   set p [expr $axis + 1]
   set a [expr $axis - 3]
   if {$axis == "3" && $mom_kin_4th_axis_direction == "MAGNITUDE_DETERMINES_DIRECTION"} {
      set dirtype 0
      global mom_sys_4th_axis_dir_mode
      if [info exists mom_sys_4th_axis_dir_mode] {
        if {$mom_sys_4th_axis_dir_mode == "ON"} {
          set del $dir
          if {$del == 0} {
            set del [expr $ang-$mom_prev_pos(3)]
            if {$del > 180.0} {set del [expr $del-360.0]}
            if {$del < -180.0} {set del [expr $del+360.0]}
          }
          global mom_sys_4th_axis_cur_dir
          if {$del > 0.0} {
            global mom_sys_4th_axis_clw_code
            set mom_sys_4th_axis_cur_dir $mom_sys_4th_axis_clw_code
          } elseif {$del < 0.0} {
            global mom_sys_4th_axis_cclw_code
            set mom_sys_4th_axis_cur_dir $mom_sys_4th_axis_cclw_code
          }
        }
      }
   } elseif { $axis == "4"  &&  $mom_kin_5th_axis_direction == "MAGNITUDE_DETERMINES_DIRECTION" } {
      set dirtype 0
      global mom_sys_5th_axis_dir_mode
      if [info exists mom_sys_5th_axis_dir_mode] {
        if {$mom_sys_5th_axis_dir_mode == "ON"} {
          set del $dir
          if {$del == 0} {
            set del [expr $ang-$mom_prev_pos(4)]
            if {$del > 180.0} {set del [expr $del-360.0]}
            if {$del < -180.0} {set del [expr $del+360.0]}
          }
          global mom_sys_5th_axis_cur_dir
          if {$del > 0.0} {
            global mom_sys_5th_axis_clw_code
            set mom_sys_5th_axis_cur_dir $mom_sys_5th_axis_clw_code
          } elseif {$del < 0.0} {
            global mom_sys_5th_axis_cclw_code
            set mom_sys_5th_axis_cur_dir $mom_sys_5th_axis_cclw_code
          }
        }
      }
   } else {
      set dirtype 1
   }

   if {$mode == 1} {
      set mom_out_angle_pos($a) $angle
   } elseif {$dirtype == 0} {

      if {$axis == 3} {
         set mom_out_angle_pos($a) [ROTSET $ang  $mom_prev_out_angle_pos(0)  $mom_kin_4th_axis_direction  $mom_kin_4th_axis_leader  mom_sys_leader(fourth_axis)  $mom_kin_4th_axis_min_limit  $mom_kin_4th_axis_max_limit]
      } else {
         set mom_out_angle_pos($a) [ROTSET $ang  $mom_prev_out_angle_pos(1)  $mom_kin_5th_axis_direction   $mom_kin_5th_axis_leader   mom_sys_leader(fifth_axis)  $mom_kin_5th_axis_min_limit  $mom_kin_5th_axis_max_limit]
#MOM_output_literal "mom_out_angle_pos   $mom_out_angle_pos($a) dirtype $dirtype"
      }

 #     if {$axis == 3} {set prot $mom_prev_out_angle_pos(0)}
 #     if {$axis == 4} {set prot $mom_prev_out_angle_pos(1)}
 #     if {$dir == 1 && $mom_out_angle_pos($a) < $prot} {
 #        set mom_out_angle_pos($a) [expr $mom_out_angle_pos($a) + 360.0]
 #     } elseif {$dir == -1 && $mom_out_angle_pos($a) > $prot} {
 #        set mom_out_angle_pos($a) [expr $mom_out_angle_pos($a) - 360.0]
 #     }
   } elseif {$dirtype == "1"} {

      if {$dir == -1} {
         if {$axis == 3} {
            set mom_sys_leader(fourth_axis) $mom_kin_4th_axis_leader-
         } else {
            set mom_sys_leader(fifth_axis) $mom_kin_5th_axis_leader-
         }
      } elseif {$dir == 0} {
         if {$axis == 3} {
            set mom_out_angle_pos($a) [ROTSET $ang  $mom_prev_out_angle_pos(0)  $mom_kin_4th_axis_direction   $mom_kin_4th_axis_leader   mom_sys_leader(fourth_axis)  $mom_kin_4th_axis_min_limit  $mom_kin_4th_axis_max_limit]
         } else {
            set mom_out_angle_pos($a) [ROTSET $ang  $mom_prev_out_angle_pos(1)  $mom_kin_5th_axis_direction   $mom_kin_5th_axis_leader  mom_sys_leader(fifth_axis)  $mom_kin_5th_axis_min_limit  $mom_kin_5th_axis_max_limit]
         }
      } elseif {$dir == 1} {
         set mom_out_angle_pos($a) $ang
      }
   }



   if {$axis == 3} {
   #   PB_CMD_fourth_axis_rotate_move
#   MOM_do_template fourth_axis_rotate_move
   } else {
    #        set out_m128  128
    
      if {$mom_rotation_angle == 0.0} {
      	
      		set  out_m128  129
      MOM_do_template outM128
     MOM_do_template fifth_axis_rotate_move
   }
}
#  set mom_prev_pos($axis) $ang
   set mom_prev_pos($axis) $mom_out_angle_pos($a)
   MOM_reload_variable -a mom_prev_pos
   MOM_reload_variable -a mom_out_angle_pos
}

#=============================================================
proc MOM_lock_axis { } {
#=============================================================
  global mom_sys_lock_value mom_sys_lock_plane
  global mom_sys_lock_axis mom_sys_lock_status

   set status [SET_LOCK axis plane value]
   if {$status == "error"} {
      MOM_catch_warning
      set mom_sys_lock_status OFF
   } else {
      set mom_sys_lock_status $status
      if {$status != "OFF"} {
         set mom_sys_lock_axis $axis
         set mom_sys_lock_plane $plane
         set mom_sys_lock_value $value
         LOCK_AXIS_INITIALIZE
      }
   }
}

#=============================================================
proc PB_catch_warning { } {
#=============================================================
  global mom_sys_rotary_error mom_warning_info

   if {$mom_warning_info == "ROTARY CROSSING LIMIT."} {
      set mom_sys_rotary_error $mom_warning_info
   }
   if {$mom_warning_info == "secondary rotary position being used"} {
      set mom_sys_rotary_error $mom_warning_info
   }
}


#=============================================================
proc MOM_lintol { } {
#=============================================================
  global mom_kin_linearization_flag
  global mom_kin_linearization_tol
  global mom_lintol_status
  global mom_lintol

  if {$mom_lintol_status == "ON"} {
     set mom_kin_linearization_flag "TRUE"
     if [info exists mom_lintol] {set mom_kin_linearization_tol $mom_lintol}
  } elseif {$mom_lintol_status == "OFF"} {
     set mom_kin_linearization_flag "FALSE"
  }

  if {[info exists mom_kin_linearization_flag]} {
      set TOL [ format "%.3f" $mom_kin_linearization_tol ]
      set mom_warning_info "\tMOM_lintol->:   - $mom_kin_linearization_flag (TOL=$TOL) \n"
      MOM_output_to_listing_device $mom_warning_info  ; #  MOM_catch_warning ;
  }

  MOM_reload_kinematics

}

} ;# uplevel
}

#=============================================================
proc PB_CMD_kin_linearize_motion { } {
#=============================================================
}


#=============================================================
proc PB_CMD_kin_mill_turn_initialize { } {
#=============================================================
}


#=============================================================
proc PB_CMD_kin_mill_xzc_init { } {
#=============================================================
}


#=============================================================
proc PB_CMD_kin_set_csys { } {
#=============================================================
   if [llength [info commands PB_CMD_set_csys] ] {
      PB_CMD_set_csys
   }
}

#=============================================================
proc PB_CMD_kin_start_of_path { } {
#=============================================================
#
#  This procedure is executed at the start of every operation.
#  It will check to see if a new head (post) was loaded and
#  will then initialize any functionality specific to that post.
#
#  It will also restore the initial Start of Program or End
#  of program event procedures.
#
#  DO NOT CHANGE THIS FILE UNLESS YOU KNOW WHAT YOU ARE DOING.
#  DO NOT CALL THIS PROCEDURE FROM ANY OTHER CUSTOM COMMAND.
#
  global mom_sys_head_change_init_program

   if [info exists mom_sys_head_change_init_program] {

      PB_CMD_kin_start_of_program
      unset mom_sys_head_change_init_program


     #<06-17-03 gsl> Moved from MOM_head to
     # execute start of head callback in new post's context.
      global CURRENT_HEAD
      if { [info exists CURRENT_HEAD] &&  [llength [info commands PB_start_of_HEAD__$CURRENT_HEAD]] } {
         PB_start_of_HEAD__$CURRENT_HEAD
      }

      # Restore master start & end of program handlers
      if [llength [info commands "MOM_start_of_program_save"]] {
         if [llength [info commands "MOM_start_of_program"]] {
            rename MOM_start_of_program ""
         }
         rename MOM_start_of_program_save MOM_start_of_program
      }
      if [llength [info commands "MOM_end_of_program_save"]] {
         if [llength [info commands "MOM_end_of_program"]] {
            rename MOM_end_of_program ""
         }
         rename MOM_end_of_program_save MOM_end_of_program
      }

     # Restore master head change event handler
      if [llength [info commands "MOM_head_save"]] {
         if [llength [info commands "MOM_head"]] {
            rename MOM_head ""
         }
         rename MOM_head_save MOM_head
      }
   }

  # Initialize tool time accumulator for this operation.
   if [llength [info commands PB_CMD_init_oper_tool_time] ] {
      PB_CMD_init_oper_tool_time
   }

  # Force out motion G code at the start of path.
   MOM_force once G_motion
}


#=============================================================
proc PB_CMD_kin_start_of_program { } {
#=============================================================
#
#  This procedure will execute the following custom commands for
#  initialization.  They will be executed once at the start of
#  program and again each time they are loaded as a linked post.
#  After execution they will be deleted so that they are not
#  present when a different post is loaded.  You may add a call
#  to a procedure that you want executed when a linked post is
#  loaded.
#
#  Note that when a linked post is called in, the Start of Program
#  event marker is not executed again, neither is this procedure.
#
#  DO NOT REMOVE ANY LINES FROM THIS PROCEDURE UNLESS YOU KNOW
#  WHAT YOU ARE DOING.  DO NOT CALL THIS PROCEDURE FROM ANY
#  OTHER CUSTOM COMMAND.
#
   global mom_kin_machine_type


   set command_list [list]

   if [info exists mom_kin_machine_type] {
      if { ![string match "*3_axis_mill*" $mom_kin_machine_type] &&  ![string match "*lathe*" $mom_kin_machine_type] } {

         lappend command_list  PB_CMD_kin_init_rotary
      }
   }

   lappend command_list  PB_CMD_init_pivot_offsets
   lappend command_list  PB_CMD_init_auto_retract
   lappend command_list  PB_CMD_initialize_parallel_zw_mode
   lappend command_list  PB_CMD_init_parallel_zw_mode
   lappend command_list  PB_CMD_initialize_tool_list
   lappend command_list  PB_CMD_init_tool_list
   lappend command_list  PB_CMD_init_tape_break
   lappend command_list  PB_CMD_initialize_spindle_axis
   lappend command_list  PB_CMD_init_spindle_axis
   lappend command_list  PB_CMD_initialize_helix
   lappend command_list  PB_CMD_init_helix
   lappend command_list  PB_CMD_pq_cutcom_initialize
   lappend command_list  PB_CMD_init_pq_cutcom
   lappend command_list  PB_CMD_init_new_iks

   if [info exists mom_kin_machine_type] {
      if { [string match "*3_axis_mill_turn*" $mom_kin_machine_type] } {

          lappend command_list  PB_CMD_kin_init_mill_xzc
          lappend command_list  PB_CMD_kin_mill_xzc_init
          lappend command_list  PB_CMD_kin_init_mill_turn
          lappend command_list  PB_CMD_kin_mill_turn_initialize
      }
   }

   foreach cmd $command_list {

      if [llength [info commands "$cmd"]] {

         # <PB v2.0.2>
         # Old init commands for XZC/MILL_TURN posts are not executed.
         # Parameters set by these commands in the v2.0 legacy posts
         # will need to be transfered to PB_CMD_init_mill_xzc &
         # PB_CMD_init_mill_turn commands respectively.

         switch $cmd {
            "PB_CMD_kin_mill_xzc_init" -
            "PB_CMD_kin_mill_turn_initialize" {}
            default { $cmd }
         }
         rename $cmd ""
         proc $cmd { args } {}
      }
   }
}


#=============================================================
proc PB_CMD_linearize_motion { } {
#=============================================================
}

#=============================================================
proc PB_CMD_operator_message { } {
#=============================================================
# This procedure is executed when the Operator Message command is activated.
#_______________________________________________________________________________
 global mom_operator_message  mom_operator_message_defined
 if {[info exists mom_operator_message]} {
  if {$mom_operator_message!=""} {
       MOM_output_literal "( ${mom_operator_message} )"
   }
 }
}

#=============================================================
proc PB_CMD_rapid { } {
#=============================================================
  global rapid_spindle_inhibit rapid_traverse_inhibit
  global spindle_first is_from
  global mom_cycle_spindle_axis traverse_axis1 traverse_axis2
  global mom_motion_event

   set aa(0) X ; set aa(1) Y ; set aa(2) Z

   set rapid_traverse_blk {G_adjust G_feed G_motion G_mode X Y Z fourth_axis fifth_axis S M_spindle}
   set rapid_traverse_mod {}
   PB_SET_RAPID_MOD $rapid_traverse_mod $rapid_traverse_blk aa mod_traverse
   PB_FORCE Once $mod_traverse
   MOM_do_template rapid_traverse
}


#=============================================================
proc PB_CMD_reposition_move { } {
#=============================================================
#
#  This procedure is used by rotary axis retract to reposition the
#  rotary axes after the tool has been fully retracted.
#
#  You can modify the this procedure to customize the reposition move.
#  If you need a custom command to be output with this block,
#  you must place a call a the custom command either before or after
#  the MOM_do_template command.
#
   MOM_suppress once X Y Z
   MOM_do_template rapid_traverse
}





#=============================================================
proc PB_CMD_retract_move { } {
#=============================================================
#
#  This procedure is used by rotary axis retract to move away from
#  the part.  This move is a three axis move along the tool axis at
#  a retract feedrate.
#
#  You can modify the this procedure to customize the retract move.
#  If you need a custom command to be output with this block,
#  you must place a call to the custom command either before or after
#  the MOM_do_template command.
#
#  If you need to modify the x,y or z locations you will need to do the
#  following.  (without the #)
#
#  global mom_pos
#  set mom_pos(0) 1.0
#  set mom_pos(1) 2.0
#  set mom_pos(2) 3.0

   MOM_do_template linear_move
}


#=============================================================
proc PB_CMD_set_cycle_plane { } {
#=============================================================
#
# Use this command to determine and output proper plane code
# when G17/18/19 is used in the cycle definition.
#

 #+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 # This option can be set to 1, if the address of cycle's
 # principal axis needs to be suppressed. (Ex. siemens controller)
 #+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  set suppress_principal_axis 0


 #++++++++++++++++++++++++++++++++++++++++++++++++++++++
 # This option can be set to 1, if the plane code needs
 # to be forced out @ the start of every set of cycles.
 #++++++++++++++++++++++++++++++++++++++++++++++++++++++
  set force_plane_code 0


  global mom_kin_machine_type
  global mom_kin_4th_axis_type mom_kin_4th_axis_plane
  global mom_kin_5th_axis_type
  global mom_tool_axis mom_sys_spindle_axis mom_kin_spindle_axis
  global mom_pos
  global mom_cycle_spindle_axis mom_cutcom_plane mom_pos_arc_plane


 # Default cycle spindle axis to Z
  set mom_cycle_spindle_axis 2


  if { ![string match "*3_axis_mill*" $mom_kin_machine_type] } {

    if { $mom_kin_4th_axis_type == "Head" } {

      if [EQ_is_equal [expr abs($mom_tool_axis(0))] 1.0] {
        set mom_cycle_spindle_axis 0
      }

      if [EQ_is_equal [expr abs($mom_tool_axis(1))] 1.0] {
        set mom_cycle_spindle_axis 1
      }

      if { $mom_kin_5th_axis_type == "Table" } {

        if { [EQ_is_equal [expr abs($mom_pos(3))] 90.0] || [EQ_is_equal [expr abs($mom_pos(3))] 270.0] } {

          switch $mom_kin_4th_axis_plane {
            "YZ" {
              set mom_cycle_spindle_axis 1
            }
            "ZX" {
              set mom_cycle_spindle_axis 0
            }
          }
        }
      }
    }
  }


  switch $mom_cycle_spindle_axis {
    0 {
      set mom_cutcom_plane  YZ
      set mom_pos_arc_plane YZ
      set principal_axis X
    }
    1 {
      set mom_cutcom_plane  ZX
      set mom_pos_arc_plane ZX
      set principal_axis Y
    }
    2 {
      set mom_cutcom_plane  XY
      set mom_pos_arc_plane XY
      set principal_axis Z
    }
    default {
      set mom_cutcom_plane  UNDEFINED
      set mom_pos_arc_plane UNDEFINED
      set principal_axis ""
    }
  }


  if { $suppress_principal_axis && [string length $principal_axis] > 0 } {
    MOM_suppress once $principal_axis
  }


  if { $force_plane_code } {
    global cycle_init_flag

    if { [info exists cycle_init_flag] && [string match "TRUE" $cycle_init_flag] } {
      MOM_force once G_plane
    }
  }
}





#=============================================================
proc PAUSE { args } {
#=============================================================
  global env

  if { [info exists env(PB_SUPPRESS_UGPOST_DEBUG)] &&  $env(PB_SUPPRESS_UGPOST_DEBUG) == 1 } {
return
  }


  set cam_aux_dir  [MOM_ask_env_var UGII_CAM_AUXILIARY_DIR]

  global tcl_platform

  if [string match "*windows*" $tcl_platform(platform)] {
     set ug_wish "ugwish.exe"
  } else {
     set ug_wish ugwish
  }

  if { [file exists ${cam_aux_dir}$ug_wish] && [file exists ${cam_aux_dir}mom_pause.tcl] } {

     set title ""
     set msg ""

     if { [llength $args] == 1 } {
       set msg [lindex $args 0]
     }

     if { [llength $args] > 1 } {
       set title [lindex $args 0]
       set msg [lindex $args 1]
     }

     exec ${cam_aux_dir}$ug_wish ${cam_aux_dir}mom_pause.tcl $title $msg
  }
}


#=============================================================
proc DELAY_TIME_SET {  } {
#=============================================================
  global mom_sys_delay_param mom_delay_value
  global mom_delay_revs mom_delay_mode delay_time

   # post builder provided format for the current mode:
    if {[info exists mom_sys_delay_param(${mom_delay_mode},format)] != 0} {
      MOM_set_address_format dwell $mom_sys_delay_param(${mom_delay_mode},format)
    }

    switch $mom_delay_mode {
      SECONDS {set delay_time $mom_delay_value}
      default {set delay_time $mom_delay_revs}
    }
}


#=============================================================
proc SET_ROTARY_ANGLE { v1 } {
#       .
#=============================================================
	global prev_c_value
	global prev_theta_value

	set angle $v1
	set diff [expr $angle - $prev_theta_value]

	if {[EQ_is_zero $diff]} {
		set direction 0
	} elseif {abs($diff) <= 180} {
		if {$angle > $prev_theta_value} {
			set direction -1
		} else {
			set direction 1
		}
	} else {
		if {$angle > $prev_theta_value} {
			set direction 1
		} else {
			set direction -1
		}
	}

	if {$direction == 1} {
		if {$angle >= $prev_c_value} {
			while {$angle > $prev_c_value} {
				set angle [expr $angle - 360]
			}
		} else {
			while {$angle < $prev_c_value} {
				set angle [expr $angle + 360]
			}
			set angle [expr $angle - 360.0]
		}
	} elseif {$direction == -1} {
		if {$angle <= $prev_c_value} {
				while {$angle < $prev_c_value} {
				set angle [expr $angle + 360]
			}
		} else {
			while {$angle > $prev_c_value} {
				set angle [expr $angle - 360]
			}
			set angle [expr $angle + 360.0]
		}
	} else {
		set angle $prev_c_value
	}
#    MOM_output_literal "NXT999999999999999= $angle"
	return $angle
}


#=============================================================
proc LOCK_AXIS { input_point output_point output_rotary } {
#=============================================================
  upvar $input_point ip ; upvar $output_point op ; upvar $output_rotary or

  global mom_kin_4th_axis_center_offset
  global mom_kin_5th_axis_center_offset
  global mom_sys_lock_value
  global mom_sys_lock_plane
  global mom_sys_lock_axis
  global mom_sys_unlocked_axis
  global mom_sys_4th_axis_index
  global mom_sys_5th_axis_index
  global mom_sys_linear_axis_index_1
  global mom_sys_linear_axis_index_2
  global mom_sys_rotary_axis_index
  global mom_kin_machine_resolution
  global mom_prev_lock_angle
  global mom_out_angle_pos
  global DEG2RAD
  global RAD2DEG

   if ![info exists mom_prev_lock_angle] {set mom_prev_lock_angle [expr $mom_out_angle_pos([expr $mom_sys_rotary_axis_index-3])]}

   if {![info exists mom_kin_4th_axis_center_offset]} {
       set temp(0) $ip(0)
       set temp(1) $ip(1)
       set temp(2) $ip(2)
   } else {
       VEC3_sub ip mom_kin_4th_axis_center_offset temp
   }

   if [info exists mom_kin_5th_axis_center_offset] {
      VEC3_sub temp mom_kin_5th_axis_center_offset temp
   }

   set temp(3) $ip(3)
   set temp(4) $ip(4)

   if {$mom_sys_lock_axis > 2} {
      set angle [expr ($mom_sys_lock_value-$temp($mom_sys_lock_axis))*$DEG2RAD]
      ROTATE_VECTOR $mom_sys_lock_plane $angle temp temp1
      VMOV 3 temp1 temp
      set temp($mom_sys_lock_axis) $mom_sys_lock_value
   } else {
      if {$mom_sys_lock_plane == $mom_sys_5th_axis_index} {
         set angle [expr ($temp(4))*$DEG2RAD]
         ROTATE_VECTOR $mom_sys_5th_axis_index $angle temp temp1
         VMOV 3 temp1 temp
         set temp(4) 0.0
     }
      set rad [expr sqrt($temp($mom_sys_linear_axis_index_1)*$temp($mom_sys_linear_axis_index_1) + $temp($mom_sys_linear_axis_index_2)*$temp($mom_sys_linear_axis_index_2))]
      set angle [ARCTAN $temp($mom_sys_linear_axis_index_2) $temp($mom_sys_linear_axis_index_1)]
      if { $rad < [expr abs($mom_sys_lock_value) + $mom_kin_machine_resolution]} {
         if {$mom_sys_lock_value < 0.0} {
            set temp($mom_sys_lock_axis) [expr -$rad]
         } else {
            set temp($mom_sys_lock_axis) $rad
         }
      } else {
         set temp($mom_sys_lock_axis) $mom_sys_lock_value
      }

      set temp($mom_sys_unlocked_axis)  [expr sqrt($rad*$rad - $temp($mom_sys_lock_axis)*$temp($mom_sys_lock_axis))]

      VMOV 5 temp temp1
      set temp1($mom_sys_unlocked_axis) [expr -$temp($mom_sys_unlocked_axis)]
      set ang1 [ARCTAN $temp($mom_sys_linear_axis_index_2) $temp($mom_sys_linear_axis_index_1)]
      set ang2 [ARCTAN $temp1($mom_sys_linear_axis_index_2) $temp1($mom_sys_linear_axis_index_1)]
      set temp($mom_sys_rotary_axis_index) [expr ($angle-$ang1)*$RAD2DEG]
      set temp1($mom_sys_rotary_axis_index) [expr ($angle-$ang2)*$RAD2DEG]
      set ang1 [LIMIT_ANGLE [expr $mom_prev_lock_angle-$temp($mom_sys_rotary_axis_index)]]
      set ang2 [LIMIT_ANGLE [expr $mom_prev_lock_angle-$temp1($mom_sys_rotary_axis_index)]]
      if {$ang1 > 180.0} {set ang1 [LIMIT_ANGLE [expr -$ang1]]}
      if {$ang2 > 180.0} {set ang2 [LIMIT_ANGLE [expr -$ang2]]}
      if {$ang1 > $ang2} {VMOV 5 temp1 temp}
   }

   if {[info exists mom_kin_4th_axis_center_offset]} {
      VEC3_add temp mom_kin_4th_axis_center_offset op
   } else {
      set op(0) $temp(0)
      set op(1) $temp(1)
      set op(2) $temp(2)
   }
   if {[info exists mom_kin_5th_axis_center_offset]} {
      VEC3_add op mom_kin_5th_axis_center_offset op
   }

   if {![info exists or]} {
      set or(0) 0.0
      set or(1) 0.0
   }
   set mom_prev_lock_angle $temp($mom_sys_rotary_axis_index)
   set op(3) $temp(3)
   set op(4) $temp(4)
}


#=============================================================
proc CALC_CYLINDRICAL_RETRACT_POINT { refpt axis dist ret_pt } {
#=============================================================
  upvar $refpt rfp ; upvar $axis ax ; upvar $ret_pt rtp

#
# return 0 parallel or lies on plane
#        1 unique intersection
#


#
# create plane canonical form
#
  VMOV 3 ax plane
  set plane(3) $dist

  set num [expr $plane(3)-[VEC3_dot rfp plane]]
  set dir [VEC3_dot ax plane]
  if [EQ_is_zero $dir] {return 0}
  for {set i 0} {$i < 3} {incr i} {
    set rtp($i) [expr $rfp($i) + $ax($i)*$num/$dir]
  }
  return [RETRACT_POINT_CHECK rfp ax rtp]
}


#=============================================================
proc REPOSITION_ERROR_CHECK { warn } {
#=============================================================
  global mom_kin_4th_axis_max_limit mom_kin_4th_axis_min_limit
  global mom_kin_5th_axis_max_limit mom_kin_5th_axis_min_limit
  global mom_pos mom_prev_pos mom_alt_pos mom_alt_prev_pos
  global mom_sys_rotary_error mom_warning_info mom_kin_machine_type

  if {$warn != "secondary rotary position being used" || [string index $mom_kin_machine_type 0] != 5} {
    set mom_sys_rotary_error $warn
    return
  }

  set mom_sys_rotary_error 0

  set a4 [expr $mom_alt_pos(3)+360.0]
  set a5 [expr $mom_alt_pos(4)+360.0]
  while {[expr $a4-$mom_kin_4th_axis_min_limit] > 360.0} {set a4 [expr $a4-360.0]}
  while {[expr $a5-$mom_kin_5th_axis_min_limit] > 360.0} {set a5 [expr $a5-360.0]}
  if {$a4 <= $mom_kin_4th_axis_max_limit && $a5 <= $mom_kin_5th_axis_max_limit} {return}

  for {set i 0} {$i < 2} {incr i} {
    set rot($i) [expr $mom_pos([expr $i+3]) - $mom_prev_pos([expr $i+3])]
    while {$rot($i) > 180.0} {set rot($i) [expr $rot($i)-360.0]}
    while {$rot($i) < 180.0} {set rot($i) [expr $rot($i)+360.0]}
    set rot($i) [expr abs($rot($i))]

    set rotalt($i) [expr $mom_alt_pos([expr $i+3]) - $mom_prev_pos([expr $i+3])]
    while {$rotalt($i) > 180.0} {set rotalt($i) [expr $rotalt($i)-360.0]}
    while {$rotalt($i) < 180.0} {set rotalt($i) [expr $rotalt($i)+360.0]}
    set rotalt($i) [expr abs($rotalt($i))]
  }

  if [EQ_is_equal [expr $rot(0)+$rot(1)] [expr $rotalt(0)+$rotalt(1)]] {return}
  set mom_sys_rotary_error $warn
}


#=============================================================
proc ANGLE_CHECK { a axis } {
#=============================================================
upvar $a ang

global mom_kin_4th_axis_max_limit
global mom_kin_5th_axis_max_limit
global mom_kin_4th_axis_min_limit
global mom_kin_5th_axis_min_limit
global mom_kin_4th_axis_direction
global mom_kin_5th_axis_direction

if {$axis == "4"} {
    set min $mom_kin_4th_axis_min_limit
    set max $mom_kin_4th_axis_max_limit
    set dir $mom_kin_4th_axis_direction
} else {
    set min $mom_kin_5th_axis_min_limit
    set max $mom_kin_5th_axis_max_limit
    set dir $mom_kin_5th_axis_direction
}

if {[EQ_is_equal $min 0.0] && [EQ_is_equal $max 360.0] && $dir == "MAGNITUDE_DETERMINES_DIRECTION"} {
    return 0
} else {
    while {$ang > $max && $ang > [expr $min + 360.0]} {set ang [expr $ang - 360.0]}
    while {$ang < $min && $ang < [expr $max - 360.0]} {set ang [expr $ang + 360.0]}
    if {$ang > $max || $ang < $min} {
        return -1
    } else {
        return 1
    }
}
}


#=============================================================
proc CATCH_WARNING { msg } {
#=============================================================
  global mom_warning_info
  global mom_motion_event
  global mom_event_number

   set level [info level]
   set call_stack ""
   for {set i 1} {$i < $level} {incr i} {
      set call_stack "$call_stack\[ [lindex [info level $i] 0] \]"
   }
   set mom_warning_info "$msg ($mom_motion_event $mom_event_number) $call_stack"
   MOM_catch_warning
}


#=============================================================
proc LINEARIZE_LOCK_OUTPUT {  } {
#=============================================================
   global mom_out_angle_pos
   global mom_pos
   global mom_prev_rot_ang_4th
   global mom_prev_rot_ang_5th
   global mom_kin_4th_axis_direction
   global mom_kin_5th_axis_direction
   global mom_kin_4th_axis_leader
   global mom_kin_5th_axis_leader
   global mom_sys_leader
   global mom_prev_pos
   global mom_mcs_goto
   global mom_prev_mcs_goto
   global mom_motion_distance
   global mom_feed_rate_number
   global mom_feed_rate
   global mom_kin_machine_resolution
   global mom_kin_max_frn
   global mom_kin_machine_type
   global mom_kin_4th_axis_min_limit mom_kin_4th_axis_max_limit
   global mom_kin_5th_axis_min_limit mom_kin_5th_axis_max_limit


   if ![info exists mom_prev_rot_ang_4th] {set mom_prev_rot_ang_4th 0.0}
   if ![info exists mom_prev_rot_ang_5th] {set mom_prev_rot_ang_5th 0.0}
   set mom_out_angle_pos(0)  [ROTSET $mom_pos(3) $mom_prev_rot_ang_4th $mom_kin_4th_axis_direction  $mom_kin_4th_axis_leader mom_sys_leader(fourth_axis) $mom_kin_4th_axis_min_limit $mom_kin_4th_axis_max_limit]
   if {[info exists mom_kin_5th_axis_direction]} {
       set mom_out_angle_pos(1)  [ROTSET $mom_pos(4) $mom_prev_rot_ang_5th $mom_kin_5th_axis_direction  $mom_kin_5th_axis_leader mom_sys_leader(fifth_axis) $mom_kin_5th_axis_min_limit $mom_kin_5th_axis_max_limit]
   }
#
#  Re-calcualte the distance and feed rate number
#

   VEC3_sub mom_mcs_goto mom_prev_mcs_goto delta
   set mom_motion_distance [VEC3_mag delta]
   if {[EQ_is_lt $mom_motion_distance $mom_kin_machine_resolution]} {
       set mom_feed_rate_number $mom_kin_max_frn
   } else {
       set mom_feed_rate_number [expr $mom_feed_rate / $mom_motion_distance ]
   }

   set mom_pos(3) $mom_out_angle_pos(0)

   FEEDRATE_SET

   PB_CMD_linear_move

   set mom_prev_pos(3) $mom_out_angle_pos(0)

#   MOM_reload_variable -a mom_pos
#   MOM_reload_variable -a mom_prev_pos
#   MOM_reload_variable -a mom_out_angle_pos
}


#=============================================================
proc AXIS_SET { axis } {
#=============================================================

  global mom_sys_leader

   if {$axis == "[string index $mom_sys_leader(fourth_axis) 0]AXIS"} {
      return 3
   } elseif {$axis == "[string index $mom_sys_leader(fifth_axis) 0]AXIS"} {
      return 4
   }
}


#=============================================================
proc AUTO_CLAMP_2 { out } {
#=============================================================
#
   global mom_kin_machine_type

   switch $mom_kin_machine_type {
      5_axis_dual_table -
      5_AXIS_DUAL_TABLE -
      5_axis_dual_head -
      5_AXIS_DUAL_HEAD -
      5_axis_head_table -
      5_AXIS_HEAD_TABLE {}
      default           {return}
    }

   global clamp_rotary_fifth_status

   if {![info exists clamp_rotary_fifth_status]} {set clamp_rotary_fifth_status "UNDEFINED"}

   if {$out == 0 && $clamp_rotary_fifth_status != "UNCLAMPED"} {
      PB_CMD_unclamp_fifth_axis
      set clamp_rotary_fifth_status "UNCLAMPED"
   } elseif {$out == 1 && $clamp_rotary_fifth_status != "CLAMPED"} {
      PB_CMD_clamp_fifth_axis
      set clamp_rotary_fifth_status "CLAMPED"
   }
}


#=============================================================
proc CALC_SPHERICAL_RETRACT_POINT { refpt axis cen_sphere rad_sphere int_pts } {
#=============================================================

  upvar $refpt rp ; upvar $axis ta ; upvar $cen_sphere cs
  upvar $int_pts ip

   set rad [expr $rad_sphere*$rad_sphere]
   VEC3_sub rp cs v1

   set coeff(2) 1.0
   set coeff(1) [expr ($v1(0)*$ta(0) + $v1(1)*$ta(1) + $v1(2)*$ta(2))*2.0]
   set coeff(0) [expr $v1(0)*$v1(0) + $v1(1)*$v1(1) + $v1(2)*$v1(2) - $rad]

   set num_sol [SOLVE_QUADRATIC coeff roots iroots status degree]
   if {$num_sol == 0} {return 0}

   if {[expr $roots(0)] > [expr $roots(1)] || $num_sol == 1} {
      set d $roots(0)
   } else {
      set d $roots(1)
   }
   set ip(0) [expr $rp(0) + $d*$ta(0)]
   set ip(1) [expr $rp(1) + $d*$ta(1)]
   set ip(2) [expr $rp(2) + $d*$ta(2)]

return [RETRACT_POINT_CHECK rp ta ip]
}


#=============================================================
proc SET_FEEDRATE_NUMBER { dist feed } {
#=============================================================
global mom_sys_frn_factor
global mom_kin_max_frn

  if [EQ_is_zero $dist] {
      return $mom_kin_max_frn
  } else {
      set f [expr ($mom_sys_frn_factor*$feed) / $dist ]
      if [EQ_is_lt $f $mom_kin_max_frn] {
          return $f
      } else {
          return $mom_kin_max_frn
      }
  }
}


#=============================================================
proc SOLVE_QUADRATIC { coeff rcomp icomp status degree } {
#=============================================================

  upvar $coeff c ; upvar $rcomp rc ; upvar $icomp ic
  upvar $status st ; upvar $degree deg

   set st 1
   set deg 0
   set rc(0) 0.0 ; set rc(1) 0.0
   set ic(0) 0.0 ; set ic(1) 0.0
   set mag [VEC3_mag c]
   if [EQ_is_zero $mag] {return 0}
   set acoeff [expr $c(2)/$mag]
   set bcoeff [expr $c(1)/$mag]
   set ccoeff [expr $c(0)/$mag]
   if {![EQ_is_zero $acoeff]} {
      set deg 2
      set denom [expr $acoeff*2.]
      set dscrm [expr $bcoeff*$bcoeff - $acoeff*$ccoeff*4.0]
      if [EQ_is_zero $dscrm] {
         set dsqrt1 0.0
      } else {
         set dsqrt1 [expr sqrt(abs($dscrm))]
      }
      if [EQ_is_ge $dscrm 0.0] {
         set rc(0) [expr (-$bcoeff + $dsqrt1)/$denom]
         set rc(1) [expr (-$bcoeff - $dsqrt1)/$denom]
         set st 3
         return 2
      } else {
         set rc(0) [expr -$bcoeff/$denom]
         set rc(1) $rc(0)
         set ic(0) [expr $dsqrt1/$denom]
         set ic(1) $ic(0)
         set st 2
         return 0
      }
   } elseif {![EQ_is_zero $bcoeff] } {
      set st 3
      set deg 1
      set rc(0) [expr -$ccoeff/$bcoeff]
      return 1
   } elseif [EQ_is_zero $ccoeff] {
      return 0
   } else {
      return 0
   }
}


#=============================================================
proc LOCK_AXIS_INITIALIZE {  } {
#=============================================================

  global mom_sys_lock_plane
  global mom_sys_lock_axis
  global mom_sys_unlocked_axis
  global mom_sys_unlock_plane
  global mom_sys_4th_axis_index
  global mom_sys_5th_axis_index
  global mom_sys_linear_axis_index_1
  global mom_sys_linear_axis_index_2
  global mom_sys_rotary_axis_index
  global mom_kin_4th_axis_plane
  global mom_kin_5th_axis_plane

   if {$mom_sys_lock_plane == -1} {
      if {$mom_kin_4th_axis_plane == "XY"} {
         set mom_sys_lock_plane 2
      } elseif {$mom_kin_4th_axis_plane == "ZX"} {
         set mom_sys_lock_plane 1
      } elseif {$mom_kin_4th_axis_plane == "YZ"} {
         set mom_sys_lock_plane 0
      }
   }

   if {$mom_kin_4th_axis_plane == "XY"} {
      set mom_sys_4th_axis_index 2
   } elseif {$mom_kin_4th_axis_plane == "ZX"} {
      set mom_sys_4th_axis_index 1
   } elseif {$mom_kin_4th_axis_plane == "YZ"} {
      set mom_sys_4th_axis_index 0
   }

   if {[info exists mom_kin_5th_axis_plane]} {
      if {$mom_kin_5th_axis_plane == "XY"} {
         set mom_sys_5th_axis_index 2
      } elseif {$mom_kin_5th_axis_plane == "ZX"} {
         set mom_sys_5th_axis_index 1
      } elseif {$mom_kin_5th_axis_plane == "YZ"} {
         set mom_sys_5th_axis_index 0
      }
   } else {
      set mom_sys_5th_axis_index -1
   }


     if {$mom_sys_lock_plane == 0} {
         set mom_sys_linear_axis_index_1 1
         set mom_sys_linear_axis_index_2 2
      } elseif {$mom_sys_lock_plane == 1} {
         set mom_sys_linear_axis_index_1 2
         set mom_sys_linear_axis_index_2 0
      } elseif {$mom_sys_lock_plane == 2} {
         set mom_sys_linear_axis_index_1 0
         set mom_sys_linear_axis_index_2 1
      }

      if {$mom_sys_5th_axis_index == -1} {
         set mom_sys_rotary_axis_index 3
      } else {
         set mom_sys_rotary_axis_index 4
      }

      set mom_sys_unlocked_axis [expr $mom_sys_linear_axis_index_1 + $mom_sys_linear_axis_index_2 - $mom_sys_lock_axis]
}


#=============================================================
proc LOCK_AXIS_MOTION {  } {
#=============================================================
#
#  The UDE lock_axis must be specified in the tool path
#  for the post to lock the requested axis.  The UDE lock_axis may only
#  be used for four and five axis machine tools.  A four axis post may
#  only lock an axis in the plane of the fourth axis.  For five axis
#  posts only the fifth axis may be locked.  Five axis will only
#  output correctly if the fifth axis is rotated so it is perpendicular
#  to the spindle axis.
#
  global mom_pos mom_out_angle_pos
  global mom_current_motion
  global mom_motion_type
  global mom_cycle_feed_to_pos
  global mom_cycle_feed_to mom_tool_axis
  global mom_motion_event
  global mom_sys_lock_status
  global mom_cycle_rapid_to_pos
  global mom_cycle_retract_to_pos
  global mom_cycle_rapid_to
  global mom_cycle_retract_to
  global mom_prev_pos
  global mom_kin_4th_axis_type
  global mom_kin_spindle_axis
  global mom_kin_5th_axis_type
  global mom_kin_4th_axis_plane
  global mom_sys_cycle_after_initial
  global mom_init_pos
  global mom_kin_4th_axis_min_limit
  global mom_kin_4th_axis_max_limit
  global mom_kin_5th_axis_min_limit
  global mom_kin_5th_axis_max_limit
  global mom_prev_rot_ang_4th
  global mom_prev_rot_ang_5th
  global mom_kin_4th_axis_direction
  global mom_kin_5th_axis_direction
  global mom_kin_4th_axis_leader
  global mom_kin_5th_axis_leader

  if {$mom_sys_lock_status == "ON"} {

      if {$mom_current_motion == "circular_move"} {return}
      if {![info exists mom_sys_cycle_after_initial]} {set mom_sys_cycle_after_initial "FALSE"}
      if {$mom_sys_cycle_after_initial == "FALSE"} {
          VMOV 5 mom_pos mom_init_pos
          LOCK_AXIS mom_pos mom_pos mom_out_angle_pos
          MOM_reload_variable -a mom_out_angle_pos
      }
      if {$mom_motion_type == "CYCLE"} {
        if {$mom_motion_event == "initial_move"} {
           set mom_sys_cycle_after_initial "TRUE"
           return
        }
        if {$mom_sys_cycle_after_initial == "TRUE"} {
           set mom_pos(0) [expr $mom_pos(0) - $mom_cycle_rapid_to * $mom_tool_axis(0)]
           set mom_pos(1) [expr $mom_pos(1) - $mom_cycle_rapid_to * $mom_tool_axis(1)]
           set mom_pos(2) [expr $mom_pos(2) - $mom_cycle_rapid_to * $mom_tool_axis(2)]
        }
        set mom_sys_cycle_after_initial "FALSE"
        if {$mom_kin_4th_axis_type == "Table"} {
           VMOV 3 mom_kin_spindle_axis mom_sys_spindle_axis
        } elseif {$mom_kin_5th_axis_type == "Table"} {
           VMOV 3 mom_tool_axis vec
           if {$mom_kin_4th_axis_plane == "XY"} {
              set vec(2) 0.0
           } elseif {$mom_kin_4th_axis_plane == "ZX"} {
             set vec(1) 0.0
           } elseif {$mom_kin_4th_axis_plane == "YZ"} {
             set vec(0) 0.0
           }
           set len [VEC3_unitize vec mom_sys_spindle_axis]
           if [EQ_is_zero $len] {
              set mom_sys_spindle_axis(2) 1.0
           }
        } else {
           VMOV 3 mom_tool_axis mom_sys_spindle_axis
        }

        set mom_cycle_feed_to_pos(0) [expr $mom_pos(0) + $mom_cycle_feed_to * $mom_sys_spindle_axis(0)]
        set mom_cycle_feed_to_pos(1) [expr $mom_pos(1) + $mom_cycle_feed_to * $mom_sys_spindle_axis(1)]
        set mom_cycle_feed_to_pos(2) [expr $mom_pos(2) + $mom_cycle_feed_to * $mom_sys_spindle_axis(2)]

        set mom_cycle_rapid_to_pos(0) [expr $mom_pos(0) + $mom_cycle_rapid_to * $mom_sys_spindle_axis(0)]
        set mom_cycle_rapid_to_pos(1) [expr $mom_pos(1) + $mom_cycle_rapid_to * $mom_sys_spindle_axis(1)]
        set mom_cycle_rapid_to_pos(2) [expr $mom_pos(2) + $mom_cycle_rapid_to * $mom_sys_spindle_axis(2)]

        set mom_cycle_retract_to_pos(0) [expr $mom_pos(0) + $mom_cycle_retract_to * $mom_sys_spindle_axis(0)]
        set mom_cycle_retract_to_pos(1) [expr $mom_pos(1) + $mom_cycle_retract_to * $mom_sys_spindle_axis(1)]
        set mom_cycle_retract_to_pos(2) [expr $mom_pos(2) + $mom_cycle_retract_to * $mom_sys_spindle_axis(2)]

      }
      global mom_kin_linearization_flag

      if { ($mom_kin_linearization_flag == "FALSE" || $mom_kin_linearization_flag == "0") && $mom_motion_type != "RAPID" && $mom_motion_type != "RETRACT"} {
         LINEARIZE_LOCK_MOTION
      } else {
         if ![info exists mom_prev_rot_ang_4th] {set mom_prev_rot_ang_4th 0.0}
         if ![info exists mom_prev_rot_ang_5th] {set mom_prev_rot_ang_5th 0.0}
         set mom_out_angle_pos(0)  [ROTSET $mom_pos(3) $mom_prev_rot_ang_4th $mom_kin_4th_axis_direction  $mom_kin_4th_axis_leader mom_sys_leader(fourth_axis) $mom_kin_4th_axis_min_limit $mom_kin_4th_axis_max_limit]
         if {[info exists mom_kin_5th_axis_direction]} {
           set mom_out_angle_pos(1)  [ROTSET $mom_pos(4) $mom_prev_rot_ang_5th $mom_kin_5th_axis_direction  $mom_kin_5th_axis_leader mom_sys_leader(fifth_axis) $mom_kin_5th_axis_min_limit $mom_kin_5th_axis_max_limit]
         }
      }
  }
}


#=============================================================
proc LOCK_AXIS_SUB { axis } {
#=============================================================
  global mom_pos mom_lock_axis_value_defined mom_lock_axis_value

   if {$mom_lock_axis_value_defined == 1} {
      return $mom_lock_axis_value
   } else {
      return $mom_pos($axis)
   }
}


#=============================================================
proc WORKPLANE_SET {  } {
#=============================================================
   global mom_cycle_spindle_axis
   global mom_sys_spindle_axis
   global traverse_axis1 traverse_axis2

   if { ![info exists mom_sys_spindle_axis] } {
      set mom_sys_spindle_axis(0) 0.0
      set mom_sys_spindle_axis(1) 0.0
      set mom_sys_spindle_axis(2) 1.0
   }

   if { ![info exists mom_cycle_spindle_axis] } {
      set x $mom_sys_spindle_axis(0)
      set y $mom_sys_spindle_axis(1)
      set z $mom_sys_spindle_axis(2)

      if { [EQ_is_zero $y] && [EQ_is_zero $z] } {
         set mom_cycle_spindle_axis 0
      } elseif { [EQ_is_zero $x] && [EQ_is_zero $z] } {
         set mom_cycle_spindle_axis 1
      } else {
         set mom_cycle_spindle_axis 2
      }
   }

   if { $mom_cycle_spindle_axis == 2 } {
      set traverse_axis1 0 ; set traverse_axis2 1
   } elseif { $mom_cycle_spindle_axis == 0 } {
      set traverse_axis1 1 ; set traverse_axis2 2
   } elseif { $mom_cycle_spindle_axis == 1 } {
      set traverse_axis1 0 ; set traverse_axis2 2
   }
}


#=============================================================
proc SET_LOCK { axis plane value } {
#=============================================================
  upvar $axis a ; upvar $plane p ; upvar $value v

  global mom_kin_machine_type mom_lock_axis mom_lock_axis_plane mom_lock_axis_value
  global mom_warning_info

   switch $mom_kin_machine_type {
      4_axis_head -
      4_AXIS_HEAD -
      4_axis_table -
      4_AXIS_TABLE -
      mill_turn -
      MILL_TURN            {set mtype 4}
      5_axis_dual_table -
      5_AXIS_DUAL_TABLE -
      5_axis_dual_head -
      5_AXIS_DUAL_HEAD -
      5_axis_head_table -
      5_AXIS_HEAD_TABLE    {set mtype 5}
      default {
         set mom_warning_info "Set lock only vaild for 4 and 5 axis machines"
         return "error"
      }
   }

   set p -1

   switch $mom_lock_axis {
      OFF {
         global mom_sys_lock_arc_save
         global mom_kin_arc_output_mode
         if {[info exists mom_sys_lock_arc_save]} {
             set mom_kin_arc_output_mode $mom_sys_lock_arc_save
             unset mom_sys_lock_arc_save
             MOM_reload_kinematics
         }
         return "OFF"
      }
      XAXIS {
         set a 0
         switch $mom_lock_axis_plane {
            XYPLAN {
               set v [LOCK_AXIS_SUB $a]
               set p 2
            }
            YZPLAN {
               set mom_warning_info "Invalid plane for lock axis"
               return "error"
            }
            ZXPLAN {
               set v [LOCK_AXIS_SUB $a]
               set p 1
            }
            NONE {
               if {$mtype == 5} {
                  set mom_warning_info "Must specify lock axis plane for 5 axis machine"
                  return "error"
               } else {
                  set v [LOCK_AXIS_SUB $a]
               }
            }
         }
      }
      YAXIS {
         set a 1
         switch $mom_lock_axis_plane {
            XYPLAN {
               set v [LOCK_AXIS_SUB $a]
               set p 2
            }
            YZPLAN {
               set v [LOCK_AXIS_SUB $a]
               set p 0
            }
            ZXPLAN {
               set mom_warning_info "Invalid plane for lock axis"
               return "error"
            }
            NONE {
               if {$mtype == 5} {
                  set mom_warning_info "Must specify lock axis plane for 5 axis machine"
                  return "error"
               } else {
                  set v [LOCK_AXIS_SUB $a]
               }
            }
         }
      }
      ZAXIS {
         set a 2
         switch $mom_lock_axis_plane {
            YZPLAN {
               set v [LOCK_AXIS_SUB $a]
               set p 0
            }
            ZXPLAN {
               set v [LOCK_AXIS_SUB $a]
               set p 1
            }
            XYPLAN {
               set mom_warning_info "Invalid plane for lock axis"
               return "error"
            }
            NONE {
               if {$mtype == 5} {
                  set mom_warning_info "Must specify lock axis plane for 5 axis machine"
                  return "error"
               } else {
                  set v [LOCK_AXIS_SUB $a]
               }
            }
         }
      }
      FOURTH {
         set a 3
         set v [LOCK_AXIS_SUB $a]
      }
      FIFTH {
         set a 4
         set v [LOCK_AXIS_SUB $a]
      }
      AAXIS {
         set a [AXIS_SET $mom_lock_axis]
         set v [LOCK_AXIS_SUB $a]
      }
      BAXIS {
         set a [AXIS_SET $mom_lock_axis]
         set v [LOCK_AXIS_SUB $a]
      }
      CAXIS {
         set a [AXIS_SET $mom_lock_axis]
         set v [LOCK_AXIS_SUB $a]
      }
   }


   global mom_sys_lock_arc_save
   global mom_kin_arc_output_mode

   if {![info exists mom_sys_lock_arc_save]} {
      set mom_sys_lock_arc_save $mom_kin_arc_output_mode
   }
   set mom_kin_arc_output_mode "LINEAR"

   MOM_reload_kinematics

return "ON"
}


#=============================================================
proc ARCTAN { y x } {
#=============================================================
   global PI

   if [EQ_is_zero $y] { set y 0 }
   if [EQ_is_zero $x] { set x 0 }

   if { [expr $y == 0] && [expr $x == 0] } {
      return 0
   }

   set ang [expr atan2($y,$x)]

   if { $ang < 0 } {
      return [expr $ang + $PI*2]
   } else {
      return $ang
   }
}




#=============================================================
proc UNLOCK_AXIS { locked_point unlocked_point } {
#=============================================================
  upvar $locked_point ip ; upvar $unlocked_point op

  global mom_sys_4th_axis_index
  global mom_sys_5th_axis_index
  global mom_sys_lock_plane
  global mom_sys_linear_axis_index_1
  global mom_sys_linear_axis_index_2
  global mom_sys_rotary_axis_index
  global mom_kin_4th_axis_center_offset
  global mom_kin_5th_axis_center_offset
  global DEG2RAD


   if {[info exists mom_kin_4th_axis_center]} {
       VEC3_add ip mom_kin_4th_axis_center_offset temp
   } else {
       set temp(0) $ip(0)
       set temp(1) $ip(1)
       set temp(2) $ip(2)
   }
   if {[info exists mom_kin_5th_axis_center_offset]} {
      VEC3_add temp mom_kin_5th_axis_center_offset temp
   }

   set op(3) $ip(3)
   set op(4) $ip(4)

   set ang [expr $op($mom_sys_rotary_axis_index)*$DEG2RAD]
   ROTATE_VECTOR $mom_sys_lock_plane $ang temp op

   set op($mom_sys_rotary_axis_index) 0.0

   if {[info exists mom_kin_4th_axis_center_offset]} {
      VEC3_sub op mom_kin_4th_axis_center_offset op
   }
   if [info exists mom_kin_5th_axis_center_offset] {
      VEC3_sub op mom_kin_5th_axis_center_offset op
   }
}


#=============================================================
proc LINEARIZE_LOCK_MOTION {  } {
#=============================================================
#
#  This procedure linearizes the move between two positions that
#  have both linear and rotary motion.  The rotary motion is
#  created by LOCK_AXIS from the coordinates in the locked plane.
#  The combined linear and rotary moves result in non-linear
#  motion.  This procedure will break the move into shorter moves
#  that do not violate the tolerance.
#
   global mom_pos
   global mom_prev_pos
   global unlocked_pos
   global unlocked_prev_pos
   global mom_kin_linearization_tol
   global mom_kin_machine_resolution
   global mom_out_angle_pos
   global mom_prev_out_angle_pos
   global mom_tool_axis
   global mom_prev_tool_axis
   global mom_init_pos

   VMOV 5 mom_init_pos unlocked_pos
   VMOV 5 mom_init_pos save_unlocked_pos
   VMOV 5 mom_pos save_locked_pos
   VMOV 5 mom_prev_pos unlocked_prev_pos

   set tol $mom_kin_linearization_tol
   LOCK_AXIS unlocked_pos locked_pos mom_outangle_pos
   LOCK_AXIS unlocked_prev_pos locked_prev_pos mom_prev_out_angle_pos

   set loop 0
   set count 0

   while { $loop == 0 } {

      for {set i 3} {$i < 5} {incr i} {
         set del [expr $locked_pos($i) - $locked_prev_pos($i)]
         if {$del > 180.0} {
            set locked_prev_pos($i) [expr $locked_prev_pos($i)+360.0]
         } elseif {$del < -180.0} {
            set locked_prev_pos($i) [expr $locked_prev_pos($i)-360.0]
         }
      }

      set loop 1

      for {set i 0} {$i < 5} {incr i} {
         set mid_unlocked_pos($i) [expr ($unlocked_pos($i)+$unlocked_prev_pos($i))/2.0]
         set mid_locked_pos($i) [expr ($locked_pos($i)+$locked_prev_pos($i))/2.0]
      }

      UNLOCK_AXIS mid_locked_pos temp

      VEC3_sub temp mid_unlocked_pos work

      set error [VEC3_mag work]

      if {$count > 20} {

         VMOV 5 locked_pos mom_pos

         LINEARIZE_LOCK_OUTPUT

      } elseif { $error < $tol} {

         VMOV 5 locked_pos mom_pos

         LINEARIZE_LOCK_OUTPUT

         VMOV 5 unlocked_pos unlocked_prev_pos
         VMOV 5 locked_pos locked_prev_pos

         if {$count != 0} {
            VMOV 5 save_unlocked_pos unlocked_pos
            VMOV 5 save_locked_pos locked_pos
            set loop 0
            set count 0
         }

      } else {
         if {$error < $mom_kin_machine_resolution} {
            set error $mom_kin_machine_resolution
         }
         set error [expr sqrt($mom_kin_linearization_tol*.98/$error)]
         if {$error < .5} {set error .5}
         for {set i 0} {$i < 5} {incr i} {
            set locked_pos($i) [expr $locked_prev_pos($i)+($locked_pos($i)-$locked_prev_pos($i))*$error]
            set unlocked_pos($i) [expr $unlocked_prev_pos($i)+($unlocked_pos($i)-$unlocked_prev_pos($i))*$error]
         }
         LOCK_AXIS unlocked_pos locked_pos mom_outangle_pos
         set loop 0
         incr count
      }
   }
}


#=============================================================
proc ROTATE_VECTOR { plane angle input_vector output_vector } {
#=============================================================
  upvar $output_vector v ; upvar $input_vector v1

   if {$plane == 0} {
      set v(0) $v1(0)
      set v(1) [expr $v1(1)*cos($angle) - $v1(2)*sin($angle)]
      set v(2) [expr $v1(2)*cos($angle) + $v1(1)*sin($angle)]
   } elseif {$plane == 1} {
      set v(0) [expr $v1(0)*cos($angle) + $v1(2)*sin($angle)]
      set v(1) $v1(1)
      set v(2) [expr $v1(2)*cos($angle) - $v1(0)*sin($angle)]
   } elseif {$plane == 2} {
      set v(0) [expr $v1(0)*cos($angle) - $v1(1)*sin($angle)]
      set v(1) [expr $v1(1)*cos($angle) + $v1(0)*sin($angle)]
      set v(2) $v1(2)
   }
}


#=============================================================
proc AUTO_CLAMP_1 { out } {
#=============================================================
#
   global clamp_rotary_fourth_status

   if {![info exists clamp_rotary_fourth_status]} {set clamp_rotary_fourth_status "UNDEFINED"}

   if {$out  == 0 && $clamp_rotary_fourth_status != "UNCLAMPED"} {
      PB_CMD_unclamp_fourth_axis
      set clamp_rotary_fourth_status "UNCLAMPED"
   } elseif {$out == 1 && $clamp_rotary_fourth_status != "CLAMPED"} {
      PB_CMD_clamp_fourth_axis
      set clamp_rotary_fourth_status "CLAMPED"
   }
}


#=============================================================
proc ROTSET { angle prev_angle dir kin_leader sys_leader min max } {
#=============================================================
#
#  This procedure will take an input angle and format for a specific machine.
#  It will also validate that the angle is within the specified limits of
#  machine.
#
#  angle	      angle to be output.
#  prev_angle	previous angle output.  It should be mom_out_angle_pos
#  dir		can be either MAGNITUDE_DETERMINES_DIRECTION or
#		      SIGN_DETERMINES_DIRECTION
#  kin_leader	leader (usually A, B or C) defined by postbuilder
#  sys_leader     leader that is created by rotset.  It could be C-.
#  min            minimum degrees of travel for current axis
#  max            maximum degrees of travel for current axis
#
#  This procedure is called the follow functions.
#  LOCK_AXIS, RETRACT_ROTARY_AXIS, MOM_rotate, LINEARIZE_OUTPUT and MILL_TURN
#
#
#=============================================================

   upvar $sys_leader lead

#
#  Make sure angle is 0-360 to start with.
#
   LIMIT_ANGLE $angle

   if {$dir == "MAGNITUDE_DETERMINES_DIRECTION"} {
#
#  If magnitude determines direction and total travel is less than or equal
#  to 360, we can assume there is at most one valid solution.  Find it and
#  leave.  Check for the total travel being less than 360 and give a warning
#  if a valid position cannot be found.
#
      set travel [expr $max - $min]
      if {$travel <= 360.0} {
          while {$angle < $min} {set angle [expr $angle + 360.0]}
          while {$angle > $max} {set angle [expr $angle - 360.0]}
          if {$angle < $min} {
              global mom_warning_info
              set mom_warning_info "$kin_leader-axis is under minimum or over maximum.  Assumed default."
              MOM_catch_warning
          }
      } else {
#
#  If magnitude determines direction and total travel is greater than
#  360, we need to find the best solution that cause a move of 180 degree
#  or less.
#
          while {[expr abs([expr $angle - $prev_angle])] > 180.0} {
              if {[expr $angle - $prev_angle] < -180.0} {
                  set angle [expr $angle + 360.0]
              } elseif {[expr $angle - $prev_angle] > 180.0} {
                  set angle [expr $angle - 360.0]
              }
          }
#
#  Check for the best solution being out of the travel limits.  Use the
#  next best valid solution.
#
          while {$angle < $min} {set angle [expr $angle + 360.0]}
          while {$angle > $max} {set angle [expr $angle - 360.0]}
      }
   } elseif {$dir == "SIGN_DETERMINES_DIRECTION"} {
#
#  Sign determines direction.  Determine whether the shortest distance is
#  clockwise or counterclockwise.  If counterclockwise append a "-" sign
#  to the address leader.
#
      set del [expr $angle-$prev_angle]
      if {($del < 0.0 && $del > -180.0) || $del > 180.0} {
          set lead "$kin_leader-"
      } else {
          set lead $kin_leader
      }
#
#  There are no alternate solutions if the position is out of limits.  Give
#  a warning a leave.
#
      if {$angle < $min || $angle > $max} {
          global mom_warning_info
          set mom_warning_info "$kin_leader-axis is under minimum or over maximum.  Assumed default."
          MOM_catch_warning
      }
   }

return $angle
}


#=============================================================
proc LIMIT_ANGLE { a } {
#=============================================================

   while {$a < 0.0} {set a [expr $a+360.0]}
   while {$a >= 360.0} {set a [expr $a-360.0]}

return $a
}


#=============================================================
proc EQ_is_zero { s } {
#=============================================================
   global mom_system_tolerance

   if [info exists mom_system_tolerance] {
      if { [expr abs($s)] <= $mom_system_tolerance } { return 1 } else { return 0 }
   } else {
      return 0
   }
}


#=============================================================
proc VMOV { n p1 p2 } {
#=============================================================
  upvar $p1 v1 ; upvar $p2 v2

   for {set i 0} {$i < $n} {incr i} {
      set v2($i) $v1($i)
   }
}


#=============================================================
proc EQ_is_equal { s t } {
#=============================================================
   global mom_system_tolerance

   if [info exists mom_system_tolerance] {
      if { [expr abs($s - $t)] <= $mom_system_tolerance } { return 1 } else { return 0 }
   } else {
      return 0
   }
}


#=============================================================
proc AUTO_CLAMP {  } {
#=============================================================
#
#  This procedure is used to automatically output clamp and unclamp
#  codes.  This procedure must be placed in the the procedure
#  << PB_CMD_kin_before_motion >>.  By default this procedure will
#  output M10 or M11 to do fourth axis clamping and unclamping or
#  M12 or M13 to do fifth axis clamping and unclamping.
#

   global mom_pos
   global mom_prev_pos
   global mom_sys_auto_clamp


   if {![info exists mom_sys_auto_clamp]} {return}
   if {$mom_sys_auto_clamp != "ON"} {return}

   set rotary_out [EQ_is_equal $mom_pos(3) $mom_prev_pos(3)]

   AUTO_CLAMP_1 $rotary_out

   set rotary_out [EQ_is_equal $mom_pos(4) $mom_prev_pos(4)]

   AUTO_CLAMP_2 $rotary_out
}




#=============================================================
proc RETRACT_POINT_CHECK { refpt axis retpt } {
#=============================================================
  upvar $refpt rfp ; upvar $axis ax ; upvar $retpt rtp

#
#  determine if retraction point is "below" the retraction plane
#  if the tool is already in a safe position, do not retract
#
#  return 0	no retract needed
#         1     retraction needed
#

  VEC3_sub rtp rfp vec
  if {[VEC3_is_zero vec]} {return 0}
  set x [VEC3_unitize vec vec1]
  set dir [VEC3_dot ax vec1]
  if {$dir <= 0.0} {
    return 0
  } else {
    return 1
  }
}


#=============================================================
proc ROTARY_AXIS_RETRACT {  } {
#=============================================================
#
#  This procedure is used by four and five axis posts to retract
#  from the part when the rotary axis become discontinuous.  This
#  procedure is activated by setting the axis limit violation
#  action to "retract / re-engage".
#

   global mom_sys_rotary_error
   global mom_motion_event

   if {[info exists mom_sys_rotary_error] && [info exists mom_motion_event]} {
     if {$mom_sys_rotary_error != 0 && $mom_motion_event == "linear_move"} {
         global mom_kin_reengage_distance
         global mom_kin_rotary_reengage_feedrate
         global mom_kin_rapid_feed_rate
         global mom_pos
         global mom_prev_pos
         global mom_prev_rot_ang_4th mom_prev_rot_ang_5th
         global mom_kin_4th_axis_direction mom_kin_4th_axis_leader
         global mom_out_angle_pos mom_kin_5th_axis_direction mom_kin_5th_axis_leader
         global mom_kin_4th_axis_center_offset mom_kin_5th_axis_center_offset
         global mom_sys_leader mom_tool_axis mom_prev_tool_axis mom_kin_4th_axis_type
         global mom_kin_spindle_axis
         global mom_alt_pos mom_prev_alt_pos mom_feed_rate
         global mom_kin_rotary_reengage_feedrate
         global mom_feed_engage_value mom_feed_cut_value
         global mom_kin_4th_axis_limit_action mom_warning_info
         global mom_kin_4th_axis_min_limit mom_kin_4th_axis_max_limit
         global mom_kin_5th_axis_min_limit mom_kin_5th_axis_max_limit

        #
        #  Check for the limit action being warning only.  If so, issue warning and leave
        #

         if {$mom_kin_4th_axis_limit_action == "Warning"} {
            set mom_warning_info  "Rotary axis limit violated, discontinuous motion may result"
            MOM_catch_warning
            unset mom_sys_rotary_error
            return
         }
        #
        # The previous rotary info is only available after the first motion.
        #
         if {![info exists mom_prev_rot_ang_4th]} {
            set mom_prev_rot_ang_4th [MOM_ask_address_value fourth_axis]
         }
         if {![info exists mom_prev_rot_ang_5th]} {
            set mom_prev_rot_ang_5th [MOM_ask_address_value fifth_axis]
         }

        #
        #  Determine the type of rotary violation encountered.  There are
        #  three distinct possibilities.
        #
        #  "ROTARY CROSSING LIMIT" and a four axis machine tool.  The fourth
        #      axis will be repositioned by either +360 or -360 before
        #      re-engaging. (roterr=0)
        #
        #  "ROTARY CROSSING LIMIT" and a five axis machine tool.  There are two
        #      possible solutions.  If the axis that crossed a limit can be
        #      repositioned by adding or subtracting 360, then that solution
        #      will be used.  (roterr=0) If there is only one position available and it is
        #      not in the valid travel limits, then the alternate position will
        #      be tested.  If valid, then the "secondary rotary position being used"
        #      method will be used. (roterr=2)
        #      If the aternate position cannot be used a warning will be given.
        #
        #  "secondary rotary position being used".  Can only occur with a five
        #      axis machine tool.  The tool will reposition to the alternate
        #      current rotary position and re-engage to the alternate current
        #      linear position.  (roterr=1)
        #
        #      (roterr=0)
        #      Rotary Reposition : mom_prev_pos(3,4) +- 360
        #      Linear Re-Engage : mom_prev_pos(0,1,2)
        #      Final End Point : mom_pos(0-4)
        #
        #      (roterr=1)
        #      Rotary Reposition : mom_prev_alt_pos(3,4)
        #      Linear Re-Engage : mom_prev_alt_pos(0,1,2)
        #      Final End Point : mom_pos(0-4)
        #
        #      (roterr=2)
        #      Rotary Reposition : mom_prev_alt_pos(3,4)
        #      Linear Re-Engage : mom_prev_alt_pos(0,1,2)
        #      Final End Point : mom_alt_pos(0-4)
        #
        #      For all cases, a warning will be given if it is not possible to
        #      to cut from the re-calculated previous position to move end point.
        #      For all valid cases the tool will, retract from the part, reposition
        #      the rotary axis and re-engage back to the part.

         if {$mom_sys_rotary_error == "ROTARY CROSSING LIMIT." } {
             global mom_kin_machine_type
             switch $mom_kin_machine_type {
                 5_axis_dual_table -
                 5_AXIS_DUAL_TABLE -
                 5_axis_dual_head -
                 5_AXIS_DUAL_HEAD -
                 5_axis_head_table -
                 5_AXIS_HEAD_TABLE {

                     set d [expr $mom_out_angle_pos(0) - $mom_prev_rot_ang_4th]

                     if {[expr abs($d)] > 180.0} {
                         set min $mom_kin_4th_axis_min_limit
                         set max $mom_kin_4th_axis_max_limit
                         if {$d > 0.0} {
                             set ang [expr $mom_prev_rot_ang_4th+360.0]
                         } else {
                             set ang [expr $mom_prev_rot_ang_4th-360.0]
                         }
                     } else {
                         set min $mom_kin_5th_axis_min_limit
                         set max $mom_kin_5th_axis_max_limit
                         set d [expr $mom_out_angle_pos(1) - $mom_prev_rot_ang_5th]
                         if {$d > 0.0} {
                             set ang [expr $mom_prev_rot_ang_5th+360.0]
                         } else {
                             set ang [expr $mom_prev_rot_ang_5th-360.0]
                         }
                     }

                     if {$ang >= $min && $ang <= $max } {
                         set roterr 0
                     } else {
                         set roterr 2
                     }
                 }
                 default {set roterr 0}
             }
         } else {
             set roterr 1
         }
         unset mom_sys_rotary_error

        # Retract from part

         VMOV 5 mom_pos save_pos
         VMOV 5 mom_prev_pos save_prev_pos
         VMOV 2 mom_out_angle_pos save_out_angle_pos
         set save_feedrate $mom_feed_rate

         global mom_sys_spindle_axis
         GET_SPINDLE_AXIS mom_prev_tool_axis

         global mom_kin_retract_type
         global mom_kin_retract_distance
         global mom_kin_retract_plane

         if { ![info exists mom_kin_retract_distance] } {
            if [info exists mom_kin_retract_plane] {
              # Convert legacy variable
               set mom_kin_retract_distance $mom_kin_retract_plane
            } else {
               set mom_kin_retract_distance 10.0
            }
         }

         if { ![info exists mom_kin_retract_type] } {
            set mom_kin_retract_type "DISTANCE"
         }

        # Pre-release type conversion
         if [string match "PLANE" $mom_kin_retract_type] {
            set mom_kin_retract_type "SURFACE"
         }

         switch $mom_kin_retract_type {
             SURFACE {
               set cen(0) 0.0
               set cen(1) 0.0
               set cen(2) 0.0
               if [info exists mom_kin_4th_axis_center_offset] {
                  VEC3_add cen mom_kin_4th_axis_center_offset cen
               }

               if {$mom_kin_4th_axis_type == "Table"} {
                  set num_sol [CALC_CYLINDRICAL_RETRACT_POINT mom_prev_pos mom_kin_spindle_axis  $mom_kin_retract_distance ret_pt]
               } else {
                  set num_sol [CALC_SPHERICAL_RETRACT_POINT mom_prev_pos mom_prev_tool_axis cen  $mom_kin_retract_distance ret_pt]
               }
               if {$num_sol != 0} {VEC3_add ret_pt cen mom_pos}
             }

             DISTANCE -
             default {
               set mom_pos(0) [expr $mom_prev_pos(0)+$mom_kin_retract_distance*$mom_sys_spindle_axis(0)]
               set mom_pos(1) [expr $mom_prev_pos(1)+$mom_kin_retract_distance*$mom_sys_spindle_axis(1)]
               set mom_pos(2) [expr $mom_prev_pos(2)+$mom_kin_retract_distance*$mom_sys_spindle_axis(2)]
               set num_sol 1
             }
         }


         global mom_motion_distance
         global mom_feed_rate_number
         global mom_sys_frn_factor
         global mom_feed_retract_value
         global mom_feed_approach_value


         set dist [expr $mom_kin_reengage_distance*2.0]

         if {$num_sol != 0} {
        #
        # Retract from the part at rapid feed rate.  This is the same for all conditions.
        #
            MOM_suppress once fourth_axis fifth_axis
            set mom_feed_rate $mom_feed_retract_value
            if [EQ_is_equal $mom_feed_rate 0.0] {set mom_feed_rate $mom_kin_rapid_feed_rate}
            VEC3_sub mom_pos mom_prev_pos del_pos
            set dist [VEC3_mag del_pos]
            set mom_feed_rate_number [expr ($mom_sys_frn_factor*$mom_feed_rate)/ $dist]
            FEEDRATE_SET
            set retract "yes"
         } else {
            set mom_warning_info "Retraction geometry is defined inside of the current point.  \nNo retraction will be output.  Set the retraction distance to a greater value."
            MOM_catch_warning
            set retract "no"
         }

         if {$roterr == 0} {
#
#  This section of code handles the case where a limit forces a reposition to an angle
#  by adding or subtracting 360 until the new angle is within the limits.
#  This is either a four axis case or a five axis case where it is not a problem
#  with the inverse kinematics forcing a change of solution.
#  This is only a case of "unwinding" the table.
#
            if {$retract == "yes"} {PB_CMD_retract_move}
           #
           # move to alternate rotary position
           #
            if [info exists mom_kin_4th_axis_direction] {
               set mom_out_angle_pos(0) [ROTSET $mom_prev_pos(3) $mom_out_angle_pos(0)  $mom_kin_4th_axis_direction  $mom_kin_4th_axis_leader  mom_sys_leader(fourth_axis)  $mom_kin_4th_axis_min_limit  $mom_kin_4th_axis_max_limit]
            }
            if [info exists mom_kin_5th_axis_direction] {
               set mom_out_angle_pos(1) [ROTSET $mom_prev_pos(4) $mom_out_angle_pos(1)  $mom_kin_5th_axis_direction  $mom_kin_5th_axis_leader  mom_sys_leader(fifth_axis)  $mom_kin_5th_axis_min_limit  $mom_kin_5th_axis_max_limit]
            }
            PB_CMD_reposition_move
	     #
	     #  position back to part at approach feed rate
	     #
            GET_SPINDLE_AXIS mom_prev_tool_axis
            for {set i 0} {$i < 3} {incr i} {
               set mom_pos($i) [expr $mom_prev_pos($i)+$mom_kin_reengage_distance*$mom_sys_spindle_axis($i)]
            }
            set mom_feed_rate $mom_feed_approach_value
            if [EQ_is_equal $mom_feed_rate 0.0] {set mom_feed_rate $mom_kin_rapid_feed_rate}
            set dist [expr $dist-$mom_kin_reengage_distance]
            set mom_feed_rate_number [SET_FEEDRATE_NUMBER $dist $mom_feed_rate]
            FEEDRATE_SET
            MOM_suppress once fourth_axis fifth_axis
            PB_CMD_linear_move
	     #
	     #  feed back to part at engage feed rate
	     #
            MOM_suppress once fourth_axis fifth_axis
            if {$mom_feed_engage_value  > 0.0} {
               set mom_feed_rate $mom_feed_engage_value
            } elseif {$mom_feed_cut_value  > 0.0} {
               set mom_feed_rate $mom_feed_cut_value
            } else {
               set mom_feed_rate 10.0
            }
            VEC3_sub mom_pos mom_prev_pos del_pos
            set mom_feed_rate_number [SET_FEEDRATE_NUMBER $mom_kin_reengage_distance $mom_feed_rate]
            FEEDRATE_SET
            VMOV 3 mom_prev_pos mom_pos
            PB_CMD_linear_move

            VEC3_sub mom_pos save_pos del_pos
            set dist [VEC3_mag del_pos]
            set mom_feed_rate_number [SET_FEEDRATE_NUMBER $dist $mom_feed_rate]
            FEEDRATE_SET

            VMOV 5 save_pos mom_pos
            VMOV 5 save_prev_pos mom_prev_pos
            VMOV 2 save_out_angle_pos mom_out_angle_pos
         } else {
#
#  This section of code handles the case where there are two solutions to the tool axis inverse kinematics.
#  The post is forced to change from one solution to the other.  This causes a discontinuity in the tool path.
#  The post needs to retract, rotate to the new rotaries, then position back to the part using the alternate
#  solution.
#
            #
            #  Check for rotary axes in limits before retracting
            #
            set res [ANGLE_CHECK mom_prev_alt_pos(3) 4]
            if {$res == 1} {
                set mom_out_angle_pos(0) [ROTSET $mom_prev_alt_pos(3) $mom_prev_rot_ang_4th  $mom_kin_4th_axis_direction  $mom_kin_4th_axis_leader  mom_sys_leader(fourth_axis)  $mom_kin_4th_axis_min_limit  $mom_kin_4th_axis_max_limit]
            } elseif {$res == 0} {
                set mom_out_angle_pos(0) $mom_prev_alt_pos(3)
            } else {
                set mom_warning_info "Not possible to position to alternate rotary axis positions.  Gouging may result"
                MOM_catch_warning
                VMOV 5 save_pos mom_pos
                return
           }
            set res [ANGLE_CHECK mom_prev_alt_pos(4) 5]
            if {$res == 1} {
                set mom_out_angle_pos(1) [ROTSET $mom_prev_alt_pos(4) $mom_prev_rot_ang_5th  $mom_kin_5th_axis_direction  $mom_kin_5th_axis_leader  mom_sys_leader(fifth_axis)  $mom_kin_5th_axis_min_limit  $mom_kin_5th_axis_max_limit]
            } elseif {$res == 0} {
                set mom_out_angle_pos(1) $mom_prev_alt_pos(4)
            } else {
                set mom_warning_info "Not possible to position to alternate rotary axis positions.  Gouging may result"
                MOM_catch_warning
                VMOV 5 save_pos mom_pos
                return
            }

            set mom_prev_pos(3) $mom_pos(3)
            set mom_prev_pos(4) $mom_pos(4)
            FEEDRATE_SET

            if {$retract == "yes"} {PB_CMD_retract_move}
           #
           # move to alternate rotary position
           #
            set mom_pos(3) $mom_prev_alt_pos(3)
            set mom_pos(4) $mom_prev_alt_pos(4)
            set mom_prev_rot_ang_4th $mom_out_angle_pos(0)
            set mom_prev_rot_ang_5th $mom_out_angle_pos(1)
            VMOV 3 mom_prev_pos mom_pos
            FEEDRATE_SET
            PB_CMD_reposition_move
	     #
	     #  position back to part at approach feed rate
	     #
            set mom_prev_pos(3) $mom_pos(3)
            set mom_prev_pos(4) $mom_pos(4)
            for {set i 0} {$i < 3} {incr i} {
               set mom_pos($i) [expr $mom_prev_alt_pos($i)+$mom_kin_reengage_distance*$mom_sys_spindle_axis($i)]
            }
            MOM_suppress once fourth_axis fifth_axis
            set mom_feed_rate $mom_feed_approach_value
            if [EQ_is_equal $mom_feed_rate 0.0] {set mom_feed_rate $mom_kin_rapid_feed_rate}
            set dist [expr $dist-$mom_kin_reengage_distance]
            set mom_feed_rate_number [SET_FEEDRATE_NUMBER $dist $mom_feed_rate]
            FEEDRATE_SET
            PB_CMD_linear_move

	     #
	     #  feed back to part at engage feed rate
	     #
            MOM_suppress once fourth_axis fifth_axis
            if {$mom_feed_engage_value  > 0.0} {
               set mom_feed_rate $mom_feed_engage_value
            } elseif {$mom_feed_cut_value  > 0.0} {
               set mom_feed_rate $mom_feed_cut_value
            } else {
               set mom_feed_rate 10.0
            }
            set mom_feed_rate_number [SET_FEEDRATE_NUMBER $mom_kin_reengage_distance $mom_feed_rate]
            VMOV 3 mom_prev_alt_pos mom_pos
            FEEDRATE_SET
            PB_CMD_linear_move


            VEC3_sub mom_pos save_pos del_pos
            set dist [VEC3_mag del_pos]
            if {$dist <= 0.0} {set dist $mom_kin_reengage_distance}
            set mom_feed_rate_number [SET_FEEDRATE_NUMBER $dist $mom_feed_rate]
            FEEDRATE_SET

            if {$roterr == 2} {
                VMOV 5 mom_alt_pos mom_pos
            } else {
                VMOV 5 save_pos mom_pos
            }

            set mom_out_angle_pos(0) [ROTSET $mom_pos(3) $mom_out_angle_pos(0)  $mom_kin_4th_axis_direction  $mom_kin_4th_axis_leader  mom_sys_leader(fourth_axis)  $mom_kin_4th_axis_min_limit  $mom_kin_4th_axis_max_limit]
            set mom_out_angle_pos(1) [ROTSET $mom_pos(4) $mom_out_angle_pos(1)  $mom_kin_5th_axis_direction  $mom_kin_5th_axis_leader  mom_sys_leader(fifth_axis)  $mom_kin_5th_axis_min_limit  $mom_kin_5th_axis_max_limit]

            MOM_reload_variable -a mom_out_angle_pos
            MOM_reload_variable -a mom_pos
            MOM_reload_variable -a mom_prev_pos
         }

         set save_feedrate $mom_feed_rate
         FEEDRATE_SET
      }
   }
}

#=============================================================
proc PB_CMD_linear_move { } {
#=============================================================
#
#  This procedure is used by many automatic postbuilder functions
#  to output a linear move.  Do NOT add this block to events or
#  markers.  It is a static block and it is not intended to be added
#  to events.  Do NOT change the name of this procedure.
#
#  If you need a custom command to be output with a linear move block,
#  you must place a call to the custom command either before or after
#  the MOM_do_template command.
#
#  This proc is used for:
#     simulated cycles feed moves
#     mill/turn mill linearization
#     four and five axis retract and re-engage
#

  MOM_do_template linear_move
}

#=============================================================
proc SET_SIGN_OF_RADIUS {  } {
#=============================================================
global mom_arc_radius
  global mom_arc_angle

  if {$mom_arc_angle > 180.0} {
      set mom_arc_radius [expr (-1.0 * $mom_arc_radius)]
  } else {
      set mom_arc_radius [expr abs($mom_arc_radius)]
  }
}


#=============================================================
proc TRACE {  } {
#=============================================================
   set start_idx 1

   set str ""
   set level [info level]
   for {set i $start_idx} {$i < $level} {incr i} {
      set str "${str}[lindex [info level $i] 0]\n"
   }

return $str
}


#=============================================================
proc GET_SPINDLE_AXIS { input_tool_axis } {
#=============================================================
  upvar $input_tool_axis axis

  global mom_kin_4th_axis_type
  global mom_kin_4th_axis_plane
  global mom_kin_5th_axis_type
  global mom_kin_spindle_axis
  global mom_sys_spindle_axis

  if {$mom_kin_4th_axis_type == "Table"} {
    VMOV 3 mom_kin_spindle_axis mom_sys_spindle_axis
  } elseif {$mom_kin_5th_axis_type == "Table"} {
    VMOV 3 axis vec
    if {$mom_kin_4th_axis_plane == "XY"} {
      set vec(2) 0.0
    } elseif {$mom_kin_4th_axis_plane == "ZX"} {
      set vec(1) 0.0
    } elseif {$mom_kin_4th_axis_plane == "YZ"} {
      set vec(0) 0.0
    }
    set len [VEC3_unitize vec mom_sys_spindle_axis]
    if [EQ_is_zero $len] {set mom_sys_spindle_axis(2) 1.0}
  } else {
    VMOV 3 axis mom_sys_spindle_axis
  }
}


if [info exists mom_sys_start_of_program_flag] {
   if [llength [info commands PB_CMD_kin_start_of_program] ] {
      PB_CMD_kin_start_of_program
   }
} else {
   set mom_sys_head_change_init_program 1
   set mom_sys_start_of_program_flag 1
}







